
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>ONVIF、RTSP/RTP、FFMPEG的开发实录 / iVAN</title>

    <meta name="description" content="ONVIF、RTSP/RTP、FFMPEG的开发实录 前言 本文从零基础一步步实现ONVIF协议.RTSP/RTP协议获取IPC实时视频流.FFMPEG解码.开发环境为WIN7 32位 + VS2010. 最终成功获取浩云.海康.大华的IPC实时视频流. 如果要了解本文更多细节,或者用本文作设计指导,那最好把文中提到的连接都打开,与本文对照着看. 前期准备 1.准备一个ONVIF服务器 既然开发的是客户端,那必需要有服务端了.我这里大把的IPC,好几个品牌的,就随便拿了一个. 如果没有IPC,倒是可以用 VLC media player 搭建一下.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">ONVIF、RTSP/RTP、FFMPEG的开发实录</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>前言</h2>
<pre><code>    本文从零基础一步步实现ONVIF协议、RTSP/RTP协议获取IPC实时视频流、FFMPEG解码。开发环境为WIN7 32位 + VS2010。
    最终成功获取浩云、海康、大华的IPC实时视频流。
    如果要了解本文更多细节，或者用本文作设计指导，那最好把文中提到的连接都打开，与本文对照着看。
</code></pre>
<h2>前期准备</h2>
<pre><code>1.准备一个ONVIF服务器
    既然开发的是客户端，那必需要有服务端了。我这里大把的IPC，好几个品牌的，就随便拿了一个。
    如果没有IPC，倒是可以用 VLC media player 搭建一下。或者其他播放器也可以。这个网上很多资料。

2.准备一个ONVIF 测试工具
    这个工具在ONVIF的官网上可以找到：ONVIF Device Test Tool 。

3.准备解码器相关资料及资源
    收到视频流后，需要解码。可以用ffmpeg，也可以用其他解码库。这个是后话了，等ONVIF搞定之后再搞解码也不迟。推荐链接：
    http://wenku.baidu.com/view/f8c94355c281e53a5802ffe4.html?re=view
    (Windows下使用MinGW编译ffmpeg与x265)

4.准备资料
    ONVIF协议书必看，ONVIF官网自然是不能少的。其他资料推荐几个链接：
http://www.cuplayer.com/player/PlayerCode/camera/2015/1119/2156.html
http://blog.csdn.net/gubenpeiyuan/article/details/25618177#
http://blog.csdn.net/saloon_yuan/article/details/24901597
http://www.onvif.org/onvif/ver20/util/operationIndex.html

5.准备抓包工具IPAnalyse
    关系到网络通信的有个IP抓包工具能让你省去很多麻烦，也能让你清楚的看到协议的细节。IPAnalyse很容易在网上可以下载。
</code></pre>
<h2>测试ONVIF</h2>
<pre><code>    看《ONVIF协议书》估计很多人都会云里雾里，实在搞不懂的话，那就接上IPC，打开 Test Tool，测试一下各项功能。Test Tool里可以看到整个协议的工作细节，每一步做什么，发了什么报文，收了什么报文，都可以看到。
</code></pre>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjExMTExNjE1Mzg1NDI=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjExMTExNjE3MDU0ODE=.jpg"></p>
<pre><code>    如果你没有IPC，那用VLC理论上也可以，不过我没测试过。两个VLC(一个作为服务器一个作为客户端)加上IP抓包工具，这个我用过也可以看到协议细节。不过从抓包工具里看到的只是一段段的报文，没有步骤说明，不如Test tool来得明了。
    当然，如果你看懂了ONVIF协议，那就不必搞这些。
</code></pre>
<h2>Soap及开发框架生成</h2>
<pre><code>    本人一开始并没有听过soap，只好自已查资料去了，这里也不班门弄斧。这个开发框架生成网上大把大把的资料，但系都不好使啊。每个人的开发环境都有一点点差别，以至于很多文章都不能从头至尾的跟着走一次。唯有看比较多的文章再总结一下，才能自己生成一个框架。所以我这里也不多说了，推荐链接：
</code></pre>
<p>E.<a href="http://blog.csdn.net/saloon_yuan/article/details/24901597" rel="external nofollow noreferrer">http://blog.csdn.net/saloon_yuan/article/details/24901597</a></p>
<pre><code>当然也可以不用框架。如你所见，ONVIF的实现最终不过是发送报文和接收报文，用到的功能不多的话完全可以自己手动发报文过去，再解析接收到的报文。
</code></pre>
<p>后面也会说到不用框架来发现设备。</p>
<h2>ONVIF设备发现、设备搜索</h2>
<pre><code>    设备发现的过程：客户端发送报文到239.255.255.250的3702端口(ONVIF协议规定)，服务器收到报文后再向客户端返回一个报文，客户端收到这个报文然后解析出Xaddrs，这就完成了一次设备发现。
    理论上只要报文能正确收发就可以发现设备。不过，用soap框架搜索设备的时候，多网卡、跨网段等复杂网络会出现搜索不到的问题。这时候就需要路由支持才行(网上说可以加入相关的路由协议)。
    为了解决这个问题，自己又写了一个非SOAP框架的设备发现函数。两个发现函数请看下面代码。
</code></pre>
<pre><code>/*
    SOAP初始化
*/
int UserInitSoap(struct soap *soap,struct SOAP_ENV__Header  *header)
{
    if(soap == NULL){
        return NULL;
    }
    //命名空间
    soap_set_namespaces( soap, namespaces);

    //参数设置
    int timeout = 5 ;
    soap-&gt;recv_timeout      =  timeout ;
    soap-&gt;send_timeout      =  timeout ;
    soap-&gt;connect_timeout   =  timeout ;

    // 生成GUID , Linux下叫UUID
    char buf[128];
    GUID guid;
    if(CoCreateGuid(&amp;guid)==S_OK){
        _snprintf_s(buf, sizeof(buf)
            ,"urn:uuid:%08X-%04X-%04x-%02X%02X-%02X%02X%02X%02X%02X%02X"
            , guid.Data1   , guid.Data2   , guid.Data3
            , guid.Data4[0], guid.Data4[1]
            , guid.Data4[2], guid.Data4[3], guid.Data4[4],guid.Data4[5]
            , guid.Data4[6], guid.Data4[7] );
    }
    else{
        _snprintf_s(buf, sizeof(buf),"a5e4fffc-ebb3-4e9e-913e-7eecdf0b05e8");
    }

    //初始化
    soap_default_SOAP_ENV__Header(soap, header);

    //相关参数写入句柄
    header-&gt;wsa__MessageID =(char *)soap_malloc(soap,128);
    memset(header-&gt;wsa__MessageID, 0, 128);

    memcpy(header-&gt;wsa__MessageID, buf, strlen(buf));
    header-&gt;wsa__Action = "http://schemas.xmlsoap.org/ws/2005/04/discovery/Probe";
    header-&gt;wsa__To     = "urn:schemas-xmlsoap-org:ws:2005:04:discovery";

    //写入变量
    soap-&gt;header = header;

    return 0 ;
}</code></pre>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li>
<li>17</li>
<li>18</li>
<li>19</li>
<li>20</li>
<li>21</li>
<li>22</li>
<li>23</li>
<li>24</li>
<li>25</li>
<li>26</li>
<li>27</li>
<li>28</li>
<li>29</li>
<li>30</li>
<li>31</li>
<li>32</li>
<li>33</li>
<li>34</li>
<li>35</li>
<li>36</li>
<li>37</li>
<li>38</li>
<li>39</li>
<li>40</li>
<li>41</li>
<li>42</li>
<li>43</li>
<li>44</li>
<li>45</li>
<li>46</li>
<li>47</li>
<li>48</li>
</ul>
<pre><code>    SOAP里所有要申请的空间请用带有soap_XXX()的，否则不能通过soap_del(soap);来释放所有空间。这会造成内存泄漏。
</code></pre>
<pre><code>/*
    SOAP释放
*/
int UserReleaseSoap(struct soap *soap)
{

    //soap_free(soap);
    soap_destroy(soap);
    soap_end(soap);
    soap_done(soap);
    soap_del(soap);

    /*
    The gSOAP engine uses a memory management method to allocate and deallocate memory.
    The deallocation is performed with soap_destroy() followed by soap_end().
    However, when you compile with -DDEBUG or -DSOAP_MEM_DEBUG then no memory
    is released until soap_done() is invoked. This ensures that the gSOAP engine
    can track all malloced data to verify leaks and double frees in debug mode.
    Use -DSOAP_DEBUG to use the normal debugging facilities without memory debugging.
    Note that some compilers have DEBUG enabled in the debug configuration, so this behavior
    should be expected unless you compile in release config
    */

    return 0 ;
}</code></pre>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li>
<li>17</li>
<li>18</li>
<li>19</li>
<li>20</li>
<li>21</li>
<li>22</li>
<li>23</li>
<li>24</li>
<li>25</li>
</ul>
<pre><code>    以下这里有用到类，其中IP为要发现设备IP，XAddrs为设备的端地址。要复制这段代码的，请自行修改。
</code></pre>
<pre><code>int GetVideo::FindONVIFservers()
{
    //清除错误
    this-&gt;error = 0 ;
    memset(this-&gt;error_info , 0, 1024);
    memset(this-&gt;error_info_, 0, 1024);

    int FoundDevNo = 0;     //发现的设备数
    int retval = SOAP_OK;   //返回值

    struct __wsdd__ProbeMatches  resp;

    struct SOAP_ENV__Header  header;
    struct soap*  soap;
    soap = soap_new();
    UserInitSoap(soap,&amp;header);

    ////////////////////////////////////////////
    //send the message broadcast and wait
    //IP Adress and PortNo, broadCast
    const char *soap_endpoint = "soap.udp://239.255.255.250:3702/"; //从ONVIF协议得来

    //范围相关参数
    wsdd__ProbeType  req;
    wsdd__ScopesType  sScope;
    soap_default_wsdd__ScopesType(soap, &amp;sScope);
    sScope.__item = "";//"http://www.onvif.org/??"
    soap_default_wsdd__ProbeType(soap, &amp;req);
    req.Scopes = &amp;sScope;
    req.Types = ""; //"dn:NetworkVideoTransmitter";

    ///////////////////////////////////////////////////////////////
    //发送10次，直到成功为止
    int time=10;
    do{
        retval = soap_send___wsdd__Probe(soap, soap_endpoint, NULL, &amp;req);
        Sleep(100);
    }while(retval != SOAP_OK &amp;&amp; time--);

    ////////////////////////////////////////////////////////////////
    //一直接收，直到收到当前IP的信息后退出，或收不到当前IP但所有已接收完退出
    while (retval == SOAP_OK)
    {
        retval = soap_recv___wsdd__ProbeMatches(soap, &amp;resp);
        //printf("\nrecv retval = %d \n",retval);

        if (retval == SOAP_OK) {
            if (!soap-&gt;error){
                FoundDevNo ++;  //找到一个设备
                if (resp.wsdd__ProbeMatches-&gt;ProbeMatch != NULL &amp;&amp;
                    resp.wsdd__ProbeMatches-&gt;ProbeMatch-&gt;XAddrs != NULL
                    ){
                    //判断IP是否是你想要找的IP
                    char *http = strstr(resp.wsdd__ProbeMatches-&gt;ProbeMatch-&gt;XAddrs, this-&gt;IP );
                    if(http!=NULL){
                        //得到XAddrs(这里认为不超过256)
                        //因为有些设备有多个XAddrs，这里要分离出一个
                        memcpy(this-&gt;XAddrs,"http://",7);
                        for(int t=0;t&lt;255-7;t++){
                            if(http[t]==' ' || http[t]=='\n' ||
                                http[t]=='\r'|| http[t]=='\0' ){
                                    retval = 1234 ; //退出while
                                    break;
                            }
                            this-&gt;XAddrs[t+7] = http[t] ;
                        }
                    }//end if(http!=NULL)
                }
            }
            else{
                retval = soap-&gt;error;   //退出while
                this-&gt;error = soap-&gt;error ; //错误代码
                const char *tmp  = *soap_faultcode(soap)   ;    //错误信息
                if(tmp)
                    memcpy(error_info , tmp , strlen(tmp ));    //复制到类
                const char *tmp_ = *soap_faultstring(soap) ;
                if(tmp_)
                    memcpy(error_info_, tmp_, strlen(tmp_));
            }
        }
        else if (soap-&gt;error){  //搜索完所有设备
            if (FoundDevNo){
                soap-&gt;error = 0 ;
                retval = 0;
            }
            else {
                retval = soap-&gt;error;
            }
            break; //退出while
        }  

        #ifdef DEBUG_INFOPRINT
        if (retval == SOAP_OK) {
            if (!soap-&gt;error){ //找到一个设备
                //打印相关信息
                if (resp.wsdd__ProbeMatches-&gt;ProbeMatch != NULL &amp;&amp; resp.wsdd__ProbeMatches-&gt;ProbeMatch-&gt;XAddrs != NULL){
                    printf("****** No %d Devices Information ******\n", FoundDevNo );
                    printf("Device Service Address  : %s\r\n", resp.wsdd__ProbeMatches-&gt;ProbeMatch-&gt;XAddrs);
                    printf("Device EP Address       : %s\r\n", resp.wsdd__ProbeMatches-&gt;ProbeMatch-&gt;wsa__EndpointReference.Address);
                    printf("Device Type             : %s\r\n", resp.wsdd__ProbeMatches-&gt;ProbeMatch-&gt;Types);
                    printf("Device Metadata Version : %d\r\n", resp.wsdd__ProbeMatches-&gt;ProbeMatch-&gt;MetadataVersion);
                    //sleep(1);
                }
            }
            else{
                printf("[%d]: recv soap error :%d, %s, %s\n", __LINE__, soap-&gt;error, *soap_faultcode(soap), *soap_faultstring(soap));
            }
        }
        else if (soap-&gt;error){
            if (FoundDevNo){
                printf("Search end! Find %d Device! \n", FoundDevNo);
            }
            else {
                printf("No Device found!\n");
            }
            break;
        }
        #endif
    }

    //错误处理
    if(retval!=1234){
        this-&gt;error = NO_DEVICE ;
        memcpy(this-&gt;error_info_, "ONVIF:  this device NOT found\n", 128);
        char tmp[128];
        sprintf_s(tmp,128,"ONVIF:  found %d devices \n",FoundDevNo);
        memcpy(this-&gt;error_info, tmp, 128);
    }

    ////////////////////////////////////////////////
    // 退出
    Sleep(10);
    UserReleaseSoap(soap);

    return retval;
}</code></pre>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li>
<li>17</li>
<li>18</li>
<li>19</li>
<li>20</li>
<li>21</li>
<li>22</li>
<li>23</li>
<li>24</li>
<li>25</li>
<li>26</li>
<li>27</li>
<li>28</li>
<li>29</li>
<li>30</li>
<li>31</li>
<li>32</li>
<li>33</li>
<li>34</li>
<li>35</li>
<li>36</li>
<li>37</li>
<li>38</li>
<li>39</li>
<li>40</li>
<li>41</li>
<li>42</li>
<li>43</li>
<li>44</li>
<li>45</li>
<li>46</li>
<li>47</li>
<li>48</li>
<li>49</li>
<li>50</li>
<li>51</li>
<li>52</li>
<li>53</li>
<li>54</li>
<li>55</li>
<li>56</li>
<li>57</li>
<li>58</li>
<li>59</li>
<li>60</li>
<li>61</li>
<li>62</li>
<li>63</li>
<li>64</li>
<li>65</li>
<li>66</li>
<li>67</li>
<li>68</li>
<li>69</li>
<li>70</li>
<li>71</li>
<li>72</li>
<li>73</li>
<li>74</li>
<li>75</li>
<li>76</li>
<li>77</li>
<li>78</li>
<li>79</li>
<li>80</li>
<li>81</li>
<li>82</li>
<li>83</li>
<li>84</li>
<li>85</li>
<li>86</li>
<li>87</li>
<li>88</li>
<li>89</li>
<li>90</li>
<li>91</li>
<li>92</li>
<li>93</li>
<li>94</li>
<li>95</li>
<li>96</li>
<li>97</li>
<li>98</li>
<li>99</li>
<li>100</li>
<li>101</li>
<li>102</li>
<li>103</li>
<li>104</li>
<li>105</li>
<li>106</li>
<li>107</li>
<li>108</li>
<li>109</li>
<li>110</li>
<li>111</li>
<li>112</li>
<li>113</li>
<li>114</li>
<li>115</li>
<li>116</li>
<li>117</li>
<li>118</li>
<li>119</li>
<li>120</li>
<li>121</li>
<li>122</li>
<li>123</li>
<li>124</li>
<li>125</li>
<li>126</li>
<li>127</li>
<li>128</li>
<li>129</li>
<li>130</li>
<li>131</li>
<li>132</li>
<li>133</li>
<li>134</li>
<li>135</li>
<li>136</li>
<li>137</li>
</ul>
<pre><code>    以上代码实现了整个设备发现的过程，最终得到设备的XAddrs。流程为：设置命名空间 &gt;&gt; 超时设置 &gt;&gt; 生成GUID &gt;&gt; 填充header &gt;&gt; 设置搜索范围 &gt;&gt; 发送报文 &gt;&gt; 接收并解析报文 。
</code></pre>
<h2>非SOAP框架 设备发现</h2>
<pre><code>    以下代码也实现了事个发现过程，用到几个类变量：this-&gt;IP是要发现的设备IP，this-&gt;Port是其端口号，this-&gt;LocalIP是用来保存与设备IP同一网段的本地IP地址，this-&gt;FIND_BASE_UDP_PORT是用于连接设备的本地端口号(如果此端口号被占用，会自动加2查找下一个)。
    关于char *cxml 报文，最直接的方法是从Test tool里复制过来，或者从抓包工具里复制出来，当然也可以复制本文的。
    流程为：输入要发现的设备IP - 判断本地是否添加了此IP网段 - 测试设备是否可以连接 - 绑定本地IP - 准备报文 - 发送报文 - 接收报文 - 解析报文 。
</code></pre>
<pre><code>/*
    获取本机IP
*/
bool GetLocalIPs(char ips[][32], int maxCnt, int *cnt)
{
    //初始化wsa
    WSADATA wsaData;
    int ret=WSAStartup(0x0202,&amp;wsaData);
    if (ret!=0){  return false; }  

    //获取主机名
    char hostname[256];
    ret=gethostname(hostname,sizeof(hostname));
    if (ret==SOCKET_ERROR){  return false; }  

    //获取主机ip
    HOSTENT* host=gethostbyname(hostname);
    if (host==NULL){  return false; }

    //转化为char*并拷贝返回
    //注意这里，如果你本地IP多于32个就可能出问题了
    *cnt=host-&gt;h_length&lt;maxCnt? host-&gt;h_length:maxCnt;
    for (int i=0;i&lt;*cnt;i++)  {
        in_addr* addr =(in_addr*)*host-&gt;h_addr_list;
        strcpy_s(ips[i], 16, inet_ntoa(addr[i]));
    }  

    WSACleanup();
    return true;
}  

/*
    TCP Online Test
*/
int TcpOnlineTest(char *IP,int Port)
{
    //加载库
    //启动SOCKET库，版本为2.0
    WSADATA wsdata;
    WSAStartup(0x0202,&amp;wsdata);  

    SOCKET PtcpFD=socket(AF_INET,SOCK_STREAM,0);

    SOCKADDR_IN addrSrv;
    addrSrv.sin_addr.S_un.S_addr=inet_addr(IP); //服务器端的地址
    addrSrv.sin_family=AF_INET;
    addrSrv.sin_port=htons(Port);               //服务器端的端口
    //connect(PtcpFD, (SOCKADDR*)&amp;addrSrv, sizeof(SOCKADDR));   //会阻塞很久才反应过来

    //设置为非阻塞模式
    //这样，在connect时，才会立马跳过，不至于等太长时间
    int error = -1;
    int len = sizeof(int);
    timeval tm;
    fd_set set;
    unsigned long ul = 1;
    ioctlsocket(PtcpFD, FIONBIO, &amp;ul); 

    int err =connect(PtcpFD, (SOCKADDR*)&amp;addrSrv, sizeof(SOCKADDR));
    if(err==-1){
        tm.tv_sec  = 3;
        tm.tv_usec = 0;
        FD_ZERO(&amp;set);
        FD_SET(PtcpFD, &amp;set);
        if( select(PtcpFD+1, NULL, &amp;set, NULL, &amp;tm) &gt; 0){
            getsockopt(PtcpFD, SOL_SOCKET, SO_ERROR, (char *)&amp;error, /*(socklen_t *)*/&amp;len); 

            if(error == 0){ err = 0; }
            else { err = -1; }
        }
        else { err = -1; }
    }//end if(err==-1)

    if(err==0){
        //设置为阻塞模式
        ul = 0;
        ioctlsocket(PtcpFD, FIONBIO, &amp;ul); 

        char buf[16]={0};
        err = send(PtcpFD, buf, 16, 0); //Online Test
        if(err!=16){
            err = -1 ;  //此IP不在线，IP或Port有误
        }
        else{ err = 0 ; }
    }

    closesocket(PtcpFD);
    WSACleanup();
    return err;
}

/*
    连接UDP
    返回： 0   -   成功
            -1  -   失败
            -2  -   绑定失败
*/
int UdpConnect(char *IP, int UdpPort, int *UdpFD)
{
    //加载库
    //启动SOCKET库，版本为2.0
    WSADATA wsdata;
    WSAStartup(0x0202,&amp;wsdata);  

    //然后赋值
    sockaddr_in  serv;
    serv.sin_family     =   AF_INET         ;
    serv.sin_addr.s_addr=   inet_addr(IP)   ;   //INADDR_ANY ;
    serv.sin_port       =   htons(UdpPort)  ;  

    //用UDP初始化套接字
    *UdpFD = socket(AF_INET,SOCK_DGRAM,0);
    if(!(*UdpFD)){ return -1; }

    // 设置该套接字为广播类型，
    bool optval =0 ;
    int res =0;
    //res =setsockopt(*UdpFD,SOL_SOCKET,SO_REUSEADDR,(char FAR *)&amp;optval,sizeof(optval)); 

    //时限
    int nNetTimeout=100;//m秒
    //setsockopt(PudpFD，SOL_S0CKET,SO_SNDTIMEO，(char *)&amp;nNetTimeout,sizeof(int));
    res|= setsockopt(*UdpFD,SOL_SOCKET,SO_RCVTIMEO,(char *)&amp;nNetTimeout,sizeof(int));

    // 缓冲区
    int nBuf=100*1024;//设置为xK
    res|= setsockopt(*UdpFD,SOL_SOCKET,SO_SNDBUF,(const char*)&amp;nBuf,sizeof(int));
    res|= setsockopt(*UdpFD,SOL_SOCKET,SO_RCVBUF,(const char*)&amp;nBuf,sizeof(int));

    if(res){ return -1; }

    // 把该套接字绑定在一个具体的地址上  !!!!!!! 注意这里 !!!!!!!
    // 这是与SOAP框架不同的地方，也是之所以可以跨网段的原因！
    res =bind(*UdpFD,(sockaddr *)&amp;serv,sizeof(sockaddr_in));
    if(res==-1){
        int errorcode =::GetLastError();
        return -2;
    }

    return 0 ;
}

/*
    关闭UDP
*/
int UdpClose(int UdpFD)
{
    closesocket(UdpFD);
    WSACleanup();
    return 0 ;
}

/*
    UDP SEND
*/
int UdpSend(int UdpFD,char*msg,int len)
{
    int ret =send(UdpFD, msg, len, 0 );
    return ret ;
}

/*
    UDP SEND TO
*/
int UdpSendto(int UdpFD,char *msg, int len, char *toIP, int toPort)
{
    int tolen = sizeof(struct sockaddr_in);  

    sockaddr_in to;
    to.sin_family       =   AF_INET         ;
    to.sin_addr.s_addr  =   inet_addr(toIP) ;   //INADDR_ANY ;
    to.sin_port         =   htons(toPort)   ;  

    int ret =sendto(UdpFD, msg, len, 0, (const sockaddr *)&amp;to, tolen);

    return ret ;
}

/*
    UDP RECV from
    返回： -1  -   没有关键字段
            len -   nonSoap_XAddrs 空间不足,返回当前XAddrs长度
*/
int UdpRecvfrom(int UdpFD,char *fromIP,char *buf,int size)
{
    //参数配置
    sockaddr_in  afrom ;
    afrom.sin_family        =   AF_INET         ;
    afrom.sin_addr.s_addr   =   INADDR_BROADCAST; //inet_addr(fromIP)   ; //INADDR_BROADCAST;
   // afrom.sin_port            =   htons(fromPort) ;  

    //接收
    int fromlength = sizeof(SOCKADDR);
    memset(buf, 0, size);
    int res =recvfrom(UdpFD,buf,size,0,(struct sockaddr FAR *)&amp;afrom,(int FAR *)&amp;fromlength);  

    //如果收到的不是指定的IP，将放弃
    //如果你要发现所有设备，这里需要修改
    if( res &amp;&amp;
        (afrom.sin_addr.S_un.S_addr != inet_addr(fromIP))
       ){
        //char *afIP =inet_ntoa(afrom.sin_addr); //only for debug
        res = 0 ;
    }

    return res ;
}

/*
    得到参数，解析报文
    返回： 0   -   成功
            -1  -   失败
            &gt;0  -   nonSoap_XAddrs空间不足
*/
int GetDiscoveryParam(char *buf,int size, char *MessageID, char *nonSoap_XAddrs,int xaddr_len)
{
    //规定搜索范围
    const char *type   = "NetworkVideoTransmitter";
    const char *Scopes = "www.onvif.org";

    //是否启用搜索范围
    int isUse_Type   = 0 ;
    int isUse_Scopes = 0 ;

    // type
    if(isUse_Type){
        char *find_type =strstr(buf, type);
        if(find_type==NULL){
            return -1 ; //不是这个类型的不必解析
        }
    }

    // Scopes
    if(isUse_Type){
        char *find_Scopes =strstr(buf, Scopes);
        if(find_Scopes==NULL){
            return -1 ; //不是这个类型的不必解析
        }
    }

    // MessageID
    char *find_uuid =strstr(buf, MessageID);
    if(find_uuid==NULL){
        return -1 ; //MessageID不相等的，不是广播给你的，不必解析
    }

    // 找到XAddrs的开始和结束处
    const char *wsddXAddrs_b = "XAddrs&gt;";//"&lt;wsdd:XAddrs&gt;";
    const char *wsddXAddrs_e = "&lt;/";//"&lt;/wsdd:XAddrs&gt;";
    char *find_XAddrs_b =strstr(buf, wsddXAddrs_b);
    char *find_XAddrs_e =strstr(find_XAddrs_b, wsddXAddrs_e);
    if(find_XAddrs_b==NULL || wsddXAddrs_e==NULL){
        return -1 ;
    }

    //取出一个XAddrs
    int len_b = strlen(wsddXAddrs_b);               //找到的XAddrs字符串头长度
    int len = find_XAddrs_e -find_XAddrs_b -len_b;  //此区间里可能包含多个XAddrs

    char *tmp = new char[len+1];
    memset(tmp, 0, len+1);
    for(int i=0;i&lt;len;i++){                     //分离出一个XAddrs
        if(find_XAddrs_b[len_b+i]!=' '){        //多个XAddrs用空格隔开
            tmp[i] = find_XAddrs_b[len_b+i] ;   //找到的字符串，除去开头
        }
        else{
            len = i ;   //len重新赋值为单个XAddrs长度
            break;
        }
    }

    // XAddrs 如果比申请空间要长
    if(len&gt;xaddr_len){
        return len ;
    }

    // 得到 XAddrs
    memset(nonSoap_XAddrs, 0, xaddr_len);
    memcpy(nonSoap_XAddrs, tmp, len);

    delete tmp ;
    return 0 ;
}

/*
    非SOAP搜索
    返回： -4  -   本地没有添加设备对应的网段
            0   -   成功
*/
int GetVideo::FindONVIFservers_nonSoap()
{
    //清除错误
    this-&gt;error = 0 ;
    memset(this-&gt;error_info_, '\0',1024);
    memset(this-&gt;error_info,  '\0',1024);

    /////////////////////////////////////////////////////////////
    //得到设备网段
    int a,b,c,d;
    char IPD[32];
    sscanf_s(this-&gt;IP,"%d.%d.%d.%d",&amp;a,&amp;b,&amp;c,&amp;d);
    sprintf_s(IPD,32,"%d.%d.%d.",a,b,c);

    //本地是否已添加当前网段
    int isAddIPD = 0 ;
    char lips[64][32];
    char *UseIP;
    int cnt = 0 ;
    GetLocalIPs(lips, 64, &amp;cnt);

    for(int i=0;i&lt;cnt;i++){ //历遍所有本地IP
        isAddIPD = 0 ;
        UseIP = strstr(lips[i], IPD);
        if(UseIP!=NULL){    //已添加
            isAddIPD = 1 ;
            memcpy(this-&gt;LocalIP, UseIP, 64); //得到本地IP
            break;
        }
    }

    if(isAddIPD==0){
        this-&gt;error = NOTADDIP ;
        memcpy(this-&gt;error_info_, "没有添加该网段",32);
        memcpy(this-&gt;error_info,  "请先添加该网段",32);
        return -4;  //返回没有该网段
    }

    //测试设备IP:Port是否可以连接
    int isConnecting = TcpOnlineTest(this-&gt;IP, this-&gt;Port);
    if(isConnecting==-1){
        this-&gt;error = NOCONNECT ;
        memcpy(this-&gt;error_info_, "该IP/Port无法连接，请检查是否填写正确",128);
        memcpy(this-&gt;error_info,  "ONVIF:Discovery IP/Port error\n",128);
        return -1;
    }

    //绑定本地IP，连接UDP
    int Dis_UdpFD = 0 ;
    int UsePort = this-&gt;FIND_BASE_UDP_PORT ;    //使用预定的端口，向下查找合适端口
    int res =0;
    for(int i=0;i&lt;512;i++){ //查找一定次数
        res =UdpConnect(UseIP, UsePort, &amp;Dis_UdpFD);
        if(res==-1){
            this-&gt;error = NOCONNECT ;
            memcpy(this-&gt;error_info_, "该IP无法创建UDP连接",64);
            memcpy(this-&gt;error_info,  "ONVIF:Discovery UDP SOCKET ERROR(-1)\n",128);
            UdpClose(Dis_UdpFD);
            return -1;
        }
        else if(res==-2){   //bind error
            UsePort+=2;     //UDP PORT 为偶数比较好
            UdpClose(Dis_UdpFD);
            Sleep(10);
        }
        else if(res==0){
            break;
        }
    }
    //如果依然绑定连接失败
    if(res==-2){
        this-&gt;error = NOCONNECT ;
        memcpy(this-&gt;error_info_, "Can't bind UDP PORT 5340-5596.(used by others now)",128);
        memcpy(this-&gt;error_info,  "ONVIF:Discovery UDP bind ERROR\n",128);
        //UdpClose(Dis_UdpFD);  //已经在上面关闭了，此处注释掉
        return -1;
    }

    /////////////////////////////////////////////////////////////////
    //准备报文
    char *cxml = {"&lt;?xml version=\"1.0\" encoding=\"UTF-8\"?&gt;&lt;SOAP-ENV:Envelope x"
                        "mlns:SOAP-ENV=\"http://www.w3.org/2003/05/soap-envelope\" x"
                        "mlns:SOAP-ENC=\"http://www.w3.org/2003/05/soap-encoding\" x"
                        "mlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" x"
                        "mlns:xsd=\"http://www.w3.org/2001/XMLSchema\" x"
                        "mlns:wsa=\"http://schemas.xmlsoap.org/ws/2004/08/addressing\" x"
                        "mlns:wsdd=\"http://schemas.xmlsoap.org/ws/2005/04/discovery\" x"
                        "mlns:chan=\"http://schemas.microsoft.com/ws/2005/02/duplex\" x"
                        "mlns:wsa5=\"http://www.w3.org/2005/08/addressing\" x"
                        "mlns:c14n=\"http://www.w3.org/2001/10/xml-exc-c14n#\" x"
                        "mlns:wsu=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd\" x"
                        "mlns:xenc=\"http://www.w3.org/2001/04/xmlenc#\" x"
                        "mlns:wsc=\"http://schemas.xmlsoap.org/ws/2005/02/sc\" x"
                        "mlns:ds=\"http://www.w3.org/2000/09/xmldsig#\" x"
                        "mlns:wsse=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd\" x"
                        "mlns:xmime=\"http://tempuri.org/xmime.xsd\" x"
                        "mlns:xop=\"http://www.w3.org/2004/08/xop/include\" x"
                        "mlns:tt=\"http://www.onvif.org/ver10/schema\" x"
                        "mlns:wsrfbf=\"http://docs.oasis-open.org/wsrf/bf-2\" x"
                        "mlns:wstop=\"http://docs.oasis-open.org/wsn/t-1\" x"
                        "mlns:wsrfr=\"http://docs.oasis-open.org/wsrf/r-2\" x"
                        "mlns:tad=\"http://www.onvif.org/ver10/analyticsdevice/wsdl\" x"
                        "mlns:tan=\"http://www.onvif.org/ver20/analytics/wsdl\" x"
                        "mlns:tdn=\"http://www.onvif.org/ver10/network/wsdl\" x"
                        "mlns:tds=\"http://www.onvif.org/ver10/device/wsdl\" x"
                        "mlns:tev=\"http://www.onvif.org/ver10/events/wsdl\" x"
                        "mlns:wsnt=\"http://docs.oasis-open.org/wsn/b-2\" x"
                        "mlns:timg=\"http://www.onvif.org/ver20/imaging/wsdl\" x"
                        "mlns:tls=\"http://www.onvif.org/ver10/display/wsdl\" x"
                        "mlns:tmd=\"http://www.onvif.org/ver10/deviceIO/wsdl\" x"
                        "mlns:tptz=\"http://www.onvif.org/ver20/ptz/wsdl\" x"
                        "mlns:trc=\"http://www.onvif.org/ver10/recording/wsdl\" x"
                        "mlns:trp=\"http://www.onvif.org/ver10/replay/wsdl\" x"
                        "mlns:trt=\"http://www.onvif.org/ver10/media/wsdl\" x"
                        "mlns:trv=\"http://www.onvif.org/ver10/receiver/wsdl\" x"
                        "mlns:tse=\"http://www.onvif.org/ver10/search/wsdl\"&gt;"
                        "&lt;SOAP-ENV:Header&gt;&lt;wsa:MessageID&gt;urn:uuid:9D7A37A4-DBFE-4bdd-A79C-74998B7A375D&lt;/wsa:MessageID&gt;"
                        "&lt;wsa:To SOAP-ENV:mustUnderstand=\"true\"&gt;urn:schemas-xmlsoap-org:ws:2005:04:discovery&lt;/wsa:To&gt;"
                        "&lt;wsa:Action SOAP-ENV:mustUnderstand=\"true\"&gt;http://schemas.xmlsoap.org/ws/2005/04/discovery/Probe&lt;/wsa:Action&gt;"
                        "&lt;/SOAP-ENV:Header&gt;&lt;SOAP-ENV:Body&gt;&lt;wsdd:Probe&gt;&lt;wsdd:Types&gt;&lt;/wsdd:Types&gt;&lt;wsdd:Scopes&gt;&lt;/wsdd:Scopes&gt;"
                        "&lt;/wsdd:Probe&gt;&lt;/SOAP-ENV:Body&gt;&lt;/SOAP-ENV:Envelope&gt;" };

    // 生成GUID , Linux下叫UUID
    char MessageID[128];
    GUID guid;
    if(CoCreateGuid(&amp;guid)==S_OK){
        _snprintf_s(MessageID, sizeof(MessageID)
            ,"urn:uuid:%08X-%04X-%04x-%02X%02X-%02X%02X%02X%02X%02X%02X"
            , guid.Data1   , guid.Data2   , guid.Data3
            , guid.Data4[0], guid.Data4[1]
            , guid.Data4[2], guid.Data4[3], guid.Data4[4],guid.Data4[5]
            , guid.Data4[6], guid.Data4[7] );
    }
    else{
        _snprintf_s(MessageID, sizeof(MessageID),"a5e4fffc-ebb3-4e9e-913e-7eecdf0b05e8");
    }

    //跳转到关键字段
    int xml_len = strlen(cxml);
    char *xml = new char[xml_len+2] ;   //从const char 到 char
    memset(xml, 0, xml_len+2);
    memcpy(xml, cxml, xml_len);
    char *tmp_xml = strstr(xml,"urn:uuid:");
    //写入MessageID
    int idlen = strlen(MessageID);
    for(int i=0;i&lt;idlen;i++){
        tmp_xml[i] = MessageID[i] ;
    }

    /////////////////////////////////////////////////////////////////
    //发送报文 

    res =UdpSendto(Dis_UdpFD, xml, xml_len,"239.255.255.250",3702); 

/*  if(xml_len&gt;1500){
        res  =UdpSendto(Dis_UdpFD,  xml,      1400,         "239.255.255.250",3702);
        res +=UdpSendto(Dis_UdpFD,  xml+1400, xml_len-1400, "239.255.255.250",3702);
    }
    else{
        res =UdpSendto(Dis_UdpFD, xml, xml_len,"239.255.255.250",3702);
    }
*/  if(res!=xml_len){
        this-&gt;error = -1 ;
        char tmp[128];
        sprintf_s(tmp,128,"UDP send(%d)!=res(%d) ERROR",xml_len,res);
        memcpy(this-&gt;error_info_, tmp,128);
        memcpy(this-&gt;error_info,  "ONVIF:Discovery UDP send ERROR\n",128);
        UdpClose(Dis_UdpFD);
        delete xml;
        return -1;
    }

    /////////////////////////////////////////////////////////////////
    //接收报文
    char buf[4096] ;
    int size = 4096 ;
    //接收10次后依然没有报文，则退出
    for(int j=0,res=0; res==0 &amp;&amp; j&lt;100; j++){
        //memset(buf, 0, 4096); //2016年11月11日
        res =UdpRecvfrom(Dis_UdpFD, this-&gt;IP, buf+res, size-res);
        Sleep(10);
    }
    //如果没有收到，再次接收
    //if(res==-1){
    //  for(res=0; res!=0; ){
    //      memset(buf, 0, 4096);
    //      res =UdpRecvfrom(Dis_UdpFD, this-&gt;IP, buf, size);
    //      Sleep(10);
    //  }
    //}
    //再次没有收到，认为出错了
    if(res==-1){
        this-&gt;error = -1 ;
        char tmp[128];
        sprintf_s(tmp,128,"UDP recv(%d) ERROR",res);
        memcpy(this-&gt;error_info_, tmp,128);
        memcpy(this-&gt;error_info,  "ONVIF:Discovery UDP recv ERROR\n",128);
        UdpClose(Dis_UdpFD);
        delete xml;
        return -1;
    }

    //////////////////////////////////////////////////////////////////////////
    //解释报文
    int resGDP =GetDiscoveryParam(buf, res, MessageID, this-&gt;XAddrs, 256);
    //XAddrs空间不足
    if(resGDP&gt;0){
        this-&gt;error = -1 ;
        char tmp[128];
        sprintf_s(tmp,128,"GetVideo: XAddrs buf overflow(256&lt;%d) ERROR",res);
        memcpy(this-&gt;error_info_, tmp,128);
        memcpy(this-&gt;error_info,  "GetVideo: 请增大XAddrs空间\n",128);
        UdpClose(Dis_UdpFD);
        delete xml;
        return -1;
    }
    //没有发现此设备
    if(resGDP==-1){
        this-&gt;error = NO_DEVICE ;
        memcpy(this-&gt;error_info_, "ONVIF:  this device NOT found\n", 128);
        memcpy(this-&gt;error_info,  "ONVIF:non Soap Discovery NO Device\n",128);
        UdpClose(Dis_UdpFD);
        delete xml;
        return -1;
    }

    // 关闭
    UdpClose(Dis_UdpFD);
    delete xml;

    return 0 ;
}</code></pre>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li>
<li>17</li>
<li>18</li>
<li>19</li>
<li>20</li>
<li>21</li>
<li>22</li>
<li>23</li>
<li>24</li>
<li>25</li>
<li>26</li>
<li>27</li>
<li>28</li>
<li>29</li>
<li>30</li>
<li>31</li>
<li>32</li>
<li>33</li>
<li>34</li>
<li>35</li>
<li>36</li>
<li>37</li>
<li>38</li>
<li>39</li>
<li>40</li>
<li>41</li>
<li>42</li>
<li>43</li>
<li>44</li>
<li>45</li>
<li>46</li>
<li>47</li>
<li>48</li>
<li>49</li>
<li>50</li>
<li>51</li>
<li>52</li>
<li>53</li>
<li>54</li>
<li>55</li>
<li>56</li>
<li>57</li>
<li>58</li>
<li>59</li>
<li>60</li>
<li>61</li>
<li>62</li>
<li>63</li>
<li>64</li>
<li>65</li>
<li>66</li>
<li>67</li>
<li>68</li>
<li>69</li>
<li>70</li>
<li>71</li>
<li>72</li>
<li>73</li>
<li>74</li>
<li>75</li>
<li>76</li>
<li>77</li>
<li>78</li>
<li>79</li>
<li>80</li>
<li>81</li>
<li>82</li>
<li>83</li>
<li>84</li>
<li>85</li>
<li>86</li>
<li>87</li>
<li>88</li>
<li>89</li>
<li>90</li>
<li>91</li>
<li>92</li>
<li>93</li>
<li>94</li>
<li>95</li>
<li>96</li>
<li>97</li>
<li>98</li>
<li>99</li>
<li>100</li>
<li>101</li>
<li>102</li>
<li>103</li>
<li>104</li>
<li>105</li>
<li>106</li>
<li>107</li>
<li>108</li>
<li>109</li>
<li>110</li>
<li>111</li>
<li>112</li>
<li>113</li>
<li>114</li>
<li>115</li>
<li>116</li>
<li>117</li>
<li>118</li>
<li>119</li>
<li>120</li>
<li>121</li>
<li>122</li>
<li>123</li>
<li>124</li>
<li>125</li>
<li>126</li>
<li>127</li>
<li>128</li>
<li>129</li>
<li>130</li>
<li>131</li>
<li>132</li>
<li>133</li>
<li>134</li>
<li>135</li>
<li>136</li>
<li>137</li>
<li>138</li>
<li>139</li>
<li>140</li>
<li>141</li>
<li>142</li>
<li>143</li>
<li>144</li>
<li>145</li>
<li>146</li>
<li>147</li>
<li>148</li>
<li>149</li>
<li>150</li>
<li>151</li>
<li>152</li>
<li>153</li>
<li>154</li>
<li>155</li>
<li>156</li>
<li>157</li>
<li>158</li>
<li>159</li>
<li>160</li>
<li>161</li>
<li>162</li>
<li>163</li>
<li>164</li>
<li>165</li>
<li>166</li>
<li>167</li>
<li>168</li>
<li>169</li>
<li>170</li>
<li>171</li>
<li>172</li>
<li>173</li>
<li>174</li>
<li>175</li>
<li>176</li>
<li>177</li>
<li>178</li>
<li>179</li>
<li>180</li>
<li>181</li>
<li>182</li>
<li>183</li>
<li>184</li>
<li>185</li>
<li>186</li>
<li>187</li>
<li>188</li>
<li>189</li>
<li>190</li>
<li>191</li>
<li>192</li>
<li>193</li>
<li>194</li>
<li>195</li>
<li>196</li>
<li>197</li>
<li>198</li>
<li>199</li>
<li>200</li>
<li>201</li>
<li>202</li>
<li>203</li>
<li>204</li>
<li>205</li>
<li>206</li>
<li>207</li>
<li>208</li>
<li>209</li>
<li>210</li>
<li>211</li>
<li>212</li>
<li>213</li>
<li>214</li>
<li>215</li>
<li>216</li>
<li>217</li>
<li>218</li>
<li>219</li>
<li>220</li>
<li>221</li>
<li>222</li>
<li>223</li>
<li>224</li>
<li>225</li>
<li>226</li>
<li>227</li>
<li>228</li>
<li>229</li>
<li>230</li>
<li>231</li>
<li>232</li>
<li>233</li>
<li>234</li>
<li>235</li>
<li>236</li>
<li>237</li>
<li>238</li>
<li>239</li>
<li>240</li>
<li>241</li>
<li>242</li>
<li>243</li>
<li>244</li>
<li>245</li>
<li>246</li>
<li>247</li>
<li>248</li>
<li>249</li>
<li>250</li>
<li>251</li>
<li>252</li>
<li>253</li>
<li>254</li>
<li>255</li>
<li>256</li>
<li>257</li>
<li>258</li>
<li>259</li>
<li>260</li>
<li>261</li>
<li>262</li>
<li>263</li>
<li>264</li>
<li>265</li>
<li>266</li>
<li>267</li>
<li>268</li>
<li>269</li>
<li>270</li>
<li>271</li>
<li>272</li>
<li>273</li>
<li>274</li>
<li>275</li>
<li>276</li>
<li>277</li>
<li>278</li>
<li>279</li>
<li>280</li>
<li>281</li>
<li>282</li>
<li>283</li>
<li>284</li>
<li>285</li>
<li>286</li>
<li>287</li>
<li>288</li>
<li>289</li>
<li>290</li>
<li>291</li>
<li>292</li>
<li>293</li>
<li>294</li>
<li>295</li>
<li>296</li>
<li>297</li>
<li>298</li>
<li>299</li>
<li>300</li>
<li>301</li>
<li>302</li>
<li>303</li>
<li>304</li>
<li>305</li>
<li>306</li>
<li>307</li>
<li>308</li>
<li>309</li>
<li>310</li>
<li>311</li>
<li>312</li>
<li>313</li>
<li>314</li>
<li>315</li>
<li>316</li>
<li>317</li>
<li>318</li>
<li>319</li>
<li>320</li>
<li>321</li>
<li>322</li>
<li>323</li>
<li>324</li>
<li>325</li>
<li>326</li>
<li>327</li>
<li>328</li>
<li>329</li>
<li>330</li>
<li>331</li>
<li>332</li>
<li>333</li>
<li>334</li>
<li>335</li>
<li>336</li>
<li>337</li>
<li>338</li>
<li>339</li>
<li>340</li>
<li>341</li>
<li>342</li>
<li>343</li>
<li>344</li>
<li>345</li>
<li>346</li>
<li>347</li>
<li>348</li>
<li>349</li>
<li>350</li>
<li>351</li>
<li>352</li>
<li>353</li>
<li>354</li>
<li>355</li>
<li>356</li>
<li>357</li>
<li>358</li>
<li>359</li>
<li>360</li>
<li>361</li>
<li>362</li>
<li>363</li>
<li>364</li>
<li>365</li>
<li>366</li>
<li>367</li>
<li>368</li>
<li>369</li>
<li>370</li>
<li>371</li>
<li>372</li>
<li>373</li>
<li>374</li>
<li>375</li>
<li>376</li>
<li>377</li>
<li>378</li>
<li>379</li>
<li>380</li>
<li>381</li>
<li>382</li>
<li>383</li>
<li>384</li>
<li>385</li>
<li>386</li>
<li>387</li>
<li>388</li>
<li>389</li>
<li>390</li>
<li>391</li>
<li>392</li>
<li>393</li>
<li>394</li>
<li>395</li>
<li>396</li>
<li>397</li>
<li>398</li>
<li>399</li>
<li>400</li>
<li>401</li>
<li>402</li>
<li>403</li>
<li>404</li>
<li>405</li>
<li>406</li>
<li>407</li>
<li>408</li>
<li>409</li>
<li>410</li>
<li>411</li>
<li>412</li>
<li>413</li>
<li>414</li>
<li>415</li>
<li>416</li>
<li>417</li>
<li>418</li>
<li>419</li>
<li>420</li>
<li>421</li>
<li>422</li>
<li>423</li>
<li>424</li>
<li>425</li>
<li>426</li>
<li>427</li>
<li>428</li>
<li>429</li>
<li>430</li>
<li>431</li>
<li>432</li>
<li>433</li>
<li>434</li>
<li>435</li>
<li>436</li>
<li>437</li>
<li>438</li>
<li>439</li>
<li>440</li>
<li>441</li>
<li>442</li>
<li>443</li>
<li>444</li>
<li>445</li>
<li>446</li>
<li>447</li>
<li>448</li>
<li>449</li>
<li>450</li>
<li>451</li>
<li>452</li>
<li>453</li>
<li>454</li>
<li>455</li>
<li>456</li>
<li>457</li>
<li>458</li>
<li>459</li>
<li>460</li>
<li>461</li>
<li>462</li>
<li>463</li>
<li>464</li>
<li>465</li>
<li>466</li>
<li>467</li>
<li>468</li>
<li>469</li>
<li>470</li>
<li>471</li>
<li>472</li>
<li>473</li>
<li>474</li>
<li>475</li>
<li>476</li>
<li>477</li>
<li>478</li>
<li>479</li>
<li>480</li>
<li>481</li>
<li>482</li>
<li>483</li>
<li>484</li>
<li>485</li>
<li>486</li>
<li>487</li>
<li>488</li>
<li>489</li>
<li>490</li>
<li>491</li>
<li>492</li>
<li>493</li>
<li>494</li>
<li>495</li>
<li>496</li>
<li>497</li>
<li>498</li>
<li>499</li>
<li>500</li>
<li>501</li>
<li>502</li>
<li>503</li>
<li>504</li>
<li>505</li>
<li>506</li>
<li>507</li>
<li>508</li>
<li>509</li>
<li>510</li>
<li>511</li>
<li>512</li>
<li>513</li>
<li>514</li>
<li>515</li>
<li>516</li>
<li>517</li>
<li>518</li>
<li>519</li>
<li>520</li>
<li>521</li>
<li>522</li>
</ul>
<pre><code>    其实设备发现，就是要得到一个XAddrs。同时看一下设备是否在线。如果你确认设备在线，并已知XAddrs，那不用发现这一步了。直接可以进行下面的操作。
</code></pre>
<h2>ONVIF获取设备能力</h2>
<pre><code>    先看代码
</code></pre>
<pre><code>/*
    获取能力
*/
void UserGetCapabilities(   struct soap *soap   ,
        struct __wsdd__ProbeMatches *resp,
        class _tds__GetCapabilities *capa_req,
        class _tds__GetCapabilitiesResponse *capa_resp,
        char *ONVIF_USER,
        char *ONVIF_PASSWORD)
{
    //申请空间
    capa_req-&gt;Category = (enum tt__CapabilityCategory *)soap_malloc(soap, sizeof(int));
    capa_req-&gt;__sizeCategory = 1;
    capa_resp-&gt;Capabilities = (class tt__Capabilities*)soap_malloc(soap,sizeof(class tt__Capabilities)) ;

    //选择要获取的设备能力
    *(capa_req-&gt;Category) = (enum tt__CapabilityCategory)(tt__CapabilityCategory__All);

    //身份认证，鉴权
    if(soap-&gt;error){ return; }
    COnvifDigest cTokenDigest(ONVIF_USER, ONVIF_PASSWORD);
    cTokenDigest.Authentication(soap,TRUE,"user");

    //获取设备能力
    if(soap-&gt;error){ return; }
    int result = soap_call___tds__GetCapabilities(soap, resp-&gt;wsdd__ProbeMatches-&gt;ProbeMatch-&gt;XAddrs, NULL, capa_req, capa_resp);

}</code></pre>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li>
<li>17</li>
<li>18</li>
<li>19</li>
<li>20</li>
<li>21</li>
<li>22</li>
<li>23</li>
<li>24</li>
<li>25</li>
<li>26</li>
<li>27</li>
<li>28</li>
</ul>
<pre><code>    小白都会问：这段代码怎么得来的呢？请看解析。
    设备发现之后是能力获取，这可以从ONVIF官方资料得知。
    能力获取是用GetCapabilities()函数，这可以从ONVIF官网的操作说明看到，也就是上那个D网址。
    那怎么知道soap的前缀呢，soap_call___tds__XXX也不是乱加的。最保守是在soapClient.cpp里Ctrl+F查找GetCapabilities关键字，就可以找到相应的函数。到你熟悉之后，你会发现tds是GetCapabilities()的命名空间，其他函数有其他的命名空间，代替一下就可以。
    关于函数调用之前，输入输出变量是什么意思，可以看ONVIF官网的函数说明。
</code></pre>
<h2>ONVIF鉴权</h2>
<pre><code>鉴权可以用函数：
</code></pre>
<pre><code>soap_wsse_add_UsernameTokenDigest(soap,"user", ONVIF_USER, ONVIF_PASSWORD); </code></pre>
<ul>
<li>1</li>
</ul>
<pre><code>    这个函数要用到openssl库，要自己编译加进去，有点麻烦。
    这里的鉴权也就是用户名、密码、随机码/时间码的base64加密，自己也可能实现。所以我选择了不用openssl库的方法。推荐链接：
http://blog.csdn.net/pony_maggie/article/details/8588888
http://blog.csdn.net/qiaowei0/article/details/42024703
    (后面的链接，一开始可以用，后来设备多了情况复杂了就似乎有点问题，我修改过，但忘记改了哪里，代码就不放上来了 so sorry)
</code></pre>
<h3>ONVIF流程</h3>
<pre><code>    可以实现能力获取这一步，就已经可以举一反三完成所有的ONVIF操作了。下面看看整体流程：
    发现设备 &gt;&gt; 获取能力 &gt;&gt; 获取媒体信息 &gt;&gt; 获取视频编码配置 &gt;&gt; 设置视频编码配置 &gt;&gt; 获取URI &gt;&gt; ONVIF完成 -&gt;  RTSP播放 -&gt; 解码
</code></pre>
<h1>RTSP/RTP协议实现</h1>
<h4>增加准备资料，推荐以下链接：</h4>
<pre><code>http://blog.csdn.net/chenyanxu/article/details/2728427
http://www.cnblogs.com/lidabo/p/3701068.html
http://blog.csdn.net/baby313/article/details/7353605
http://www.faqs.org/rfcs/
http://blog.csdn.net/gavinr/article/details/7035966
http://blog.csdn.net/nkmnkm/article/category/1066093/2
http://blog.csdn.net/cjj198561/article/details/30248963
https://my.oschina.net/u/1431835/blog/393315

都是关于RTSP及RTP包及H264等相关资料
</code></pre>
<h2>RTSP通信</h2>
<pre><code>理论自已看上面的链接，不多说，直接上代码。
</code></pre>
<pre><code>int C_RTSP_SendCMD::OPTIONS()
{
    //初始化
    memset(Authorization_Basic, '\0', 128); //用于鉴权

    //得到命令
    char *cmd = new char[1024];
    memset(cmd, 0, 1024);

    sprintf_s(cmd,1024, "OPTIONS %s RTSP/1.0\r\n"
                        "CSeq:1\r\n"
                        "User-Agent:HaoYun"
                        "\r\n"
                        "\r\n", C_RTSP_SendCMD::URI );

    //发送
    int sLenth = strlen(cmd);
    int res = send(tcpFD, cmd, sLenth, 0);

    delete cmd ;

    return res ;
}</code></pre>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li>
<li>17</li>
<li>18</li>
<li>19</li>
<li>20</li>
<li>21</li>
<li>22</li>
<li>23</li>
</ul>
<pre><code>    这里用到变量是：URI由ONVIF获取的。tcpFD是socket值。由LocalIP与设备建立的一个tcp链接，注意RTSP协议规定端口为554(有些也可能用8554)。Authorization_Basic是关于用户名和密码的一个basic64加密认证。
    这里要注意的是命令里面不要有多余的空格和多余的转义，否则不行。
    发送完命令后，马上接收服务器返回的数据，然后就可以看到资料里所说的过程了。例如：
        OPTIONS rtsp://192.168.20.136:5000/xxx666  RTSP/1.0
        CSeq: 1 //每个消息都有序号来标记，第一个包通常是option请求消息
        User-Agent: HaoYun

    服务器的回应信息包括提供的一些方法,例如:
        RTSP/1.0 200 OK
        Server: HaoYun IPC
        Cseq: 1 //每个回应消息的cseq数值和请求消息的cseq相对应
        Public: OPTIONS, DESCRIBE, SETUP, TEARDOWN, PLAY, PAUSE, SCALE, GET_PARAMETER   //服务器提供的可用的方法
</code></pre>
<h3>再来一个要认证身份的例子</h3>
<pre><code>看下面代码：
</code></pre>
<pre><code>int C_RTSP_SendCMD::DESCRIBE()
{
    //得到命令
    char *cmd = new char[1024];
    memset(cmd, 0, 1024);

    sprintf_s(cmd,1024, "DESCRIBE %s RTSP/1.0\r\n"
                        "CSeq:2\r\n"
                        "Accept: application/sdp\r\n"
                        "User-Agent:HaoYun"
                        "\r\n"
                        "\r\n", C_RTSP_SendCMD::URI );

    //要认证
    if(this-&gt;Authorization_Basic[1]!='\0'){
        char *cmd_tmp = strstr(cmd, "HaoYun");
        sprintf_s(cmd_tmp,512,  "HaoYun\r\n"
                                "Authorization: Basic %s"
                                "\r\n"
                                "\r\n", this-&gt;Authorization_Basic );

    }//end if

    //发送
    int sLenth = strlen(cmd);
    int res = send(tcpFD, cmd, sLenth, 0);

    delete cmd ;

    return res ;
}</code></pre>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li>
<li>17</li>
<li>18</li>
<li>19</li>
<li>20</li>
<li>21</li>
<li>22</li>
<li>23</li>
<li>24</li>
<li>25</li>
<li>26</li>
<li>27</li>
<li>28</li>
<li>29</li>
<li>30</li>
<li>31</li>
<li>32</li>
</ul>
<pre><code>    这里的Authorization_Basic是如下代码算出的。其中base64_bits_to_64()网上好多都有就不复制上来了。SOAP里也有，在那个鉴权函数里面，修改一下soap_malloc()就可以用了。
</code></pre>
<pre><code>int C_RTSP_SendCMD::Calc_Authorization_Basic(char *user, char *passwd)
{
    unsigned char *user_passwd = new unsigned char[600];
    memset(user_passwd, '\0', 600);
    //合并两个
    int u_len = strlen(user);
    int p_len = strlen(passwd);
    memcpy(user_passwd,         user,   u_len);
    *(user_passwd+u_len) = ':';
    memcpy(user_passwd+u_len+1, passwd, p_len);

    //base64转码
    base64_bits_to_64((unsigned char *)this-&gt;Authorization_Basic, user_passwd, u_len+p_len+1);

    delete user_passwd;
    return 0 ;
}</code></pre>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li>
<li>17</li>
</ul>
<pre><code>1.接收到DESCRIBE的sdp报文后，就在sdp里解析出 control 和 transport 来。
2.接着就是用上面得到的信息进行SETUP
3.接收到SETUP的返回信息后，解析出Session，每个通话都有一个固定的Session。
4.用Session值发送PLAY命令，成功的话，就有视频流了。这时候的流是RTP包(如果用RTP协议的话)。
5.还有一个关闭的命令TEARDOWN，在关闭的时候调用。
</code></pre>
<h2>RTP协议实现接收</h2>
<pre><code>    看完上面RTSP的链接后，就可以看下面的代码了。(如果一头雾水，请对照着那两个RTP网址来看，或对照着RTP协议也可以)
    理论不说，分析代码去。
    其中两个结构体是关于RTP头的，GetHeader()就是解析填充这两个头，代码和协议有一一对应的关系。而GetNALUnit_OneFrame()是从视频流中把一个个小RTP包拆解成NAL包，再一个个的合并成一个大帧，合并得到的帧可以送到解码器解码了。有些解码器也许不需要合并帧这一步，直接把NAL流送过去就可以解码的。
</code></pre>
<pre><code>//////////////////////////////////////////////////////////////////////////////////////////
// 2 class CH264_RTP_UNPACK_2 start  

class CH264_RTP_UNPACK_2
{
#define RTP_VERSION     2
#define BUF_SIZE        (1024 * 500)
    typedef struct
    {
        //LITTLE_ENDIAN
        unsigned char   CC;      /* 4 CSRC count                 */
        unsigned char   X;       /* 1 header extension flag      */
        unsigned char   P;       /* 1 padding flag               */
        unsigned char   V;       /* 2 packet type                */
        unsigned char   PT;      /* 7 payload type               */
        unsigned char   M;       /* 1 marker bit                 */  

        unsigned short   seq_number;        /* 16 sequence number            */
        unsigned int     time_stamp;        /* 32 timestamp                  */
        unsigned int     SSRC;              /* 32 synchronization source     */
        unsigned int     size;
    } RTP_Header_t; 

    typedef struct
    {
        unsigned char   Type;       // 5
        unsigned char   NRI;        // 2
        unsigned char   F;          // 1 在 H.264 规范中规定了这一位必须为 0
        unsigned char   FUA_Type;   // 5
        unsigned char   FUA_R;      // 1
        unsigned char   FUA_E;      // 1 置1 NAL单元的结束
        unsigned char   FUA_S;      // 1 置1 NAL单元的开始
        unsigned char   isMajor578;
        unsigned int    size;
    } NAL_Header_t; 

public:
    RTP_Header_t  m_RTP_Header;
    NAL_Header_t  m_NAL_Header;

    unsigned char *H264_OneFrame;
    int H264_1f_size;

    int pic_size3;

public:
    CH264_RTP_UNPACK_2()
    {
    }

    ~CH264_RTP_UNPACK_2()
    {
        delete H264_OneFrame ;
    }

    void CH264_RTP_UNPACK_2_Init()
    {
        memset(&amp;m_RTP_Header, 0, sizeof(RTP_Header_t));
        memset(&amp;m_NAL_Header, 0, sizeof(NAL_Header_t));
        H264_OneFrame = new unsigned char[pic_size3];
        memset(H264_OneFrame, 0, pic_size3);
        H264_1f_size = 0 ;
    }

    // 0 1 2 3 4 5 6 7 0 1 2 3 4 5 6 7 0 1 2 3 4 5 6 7 0 1 2 3 4 5 6 7
    //*-+-+-+-+-+-+-+-+*+-+-+-+-+-+-+-+*+-+-+-+-+-+-+-+*+-+-+-+-+-+-+-+
    //|V=2|P|X|  CC   |M|     PT      |       sequence number         |
    //|                         timestamp                             |
    //|                synchronization source(SSRC)                   |
    //+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
    //                      ..........
    int GetHeader(unsigned char *RTP_PackegRawBuf,int size)
    {
        if(size&lt;13){ return -2; }   //包头不会小于13的

        unsigned int ba,bb,bc,bd;   //4个字节中间变量

        m_RTP_Header.V  =  RTP_PackegRawBuf[0] &gt;&gt;6 ;
        m_RTP_Header.P  = (RTP_PackegRawBuf[0] &amp;0x20)? 1:0 ;
        m_RTP_Header.X  = (RTP_PackegRawBuf[0] &amp;0x10)? 1:0 ;
        m_RTP_Header.CC =  RTP_PackegRawBuf[0] &amp;0x0f ;

        m_RTP_Header.M  = RTP_PackegRawBuf[1] &gt;&gt;7 ;
        m_RTP_Header.PT = RTP_PackegRawBuf[1] &amp;0x7f ;

        ba = RTP_PackegRawBuf[2] ;
        bb = RTP_PackegRawBuf[3] ;
        m_RTP_Header.seq_number = (ba&lt;&lt;8) + bb ;

        ba = RTP_PackegRawBuf[4] ;
        bb = RTP_PackegRawBuf[5] ;
        bc = RTP_PackegRawBuf[6] ;
        bd = RTP_PackegRawBuf[7] ;
        m_RTP_Header.time_stamp = (ba&lt;&lt;24) +(bb&lt;&lt;16) +(bc&lt;&lt;8) +bd ;

        ba = RTP_PackegRawBuf[ 8] ;
        bb = RTP_PackegRawBuf[ 9] ;
        bc = RTP_PackegRawBuf[10] ;
        bd = RTP_PackegRawBuf[11] ;
        m_RTP_Header.SSRC = (ba&lt;&lt;24) +(bb&lt;&lt;16) +(bc&lt;&lt;8) +bd ;

        m_RTP_Header.size = 12 + m_RTP_Header.CC ;

        //NAL包
        //RTP版本不同
        if(m_RTP_Header.V!=RTP_VERSION){
            return -2;
        }
        //存在特殊报头,此处要加入特殊处理,此版本不支持固直接返回
        if(m_RTP_Header.X){
            return -2;
        }
        //《RFC3551 RTP A/V Profile》中定义动态标识区（一般96标识H264）
        //if(m_RTP_Header.PT&lt;96 || m_RTP_Header.PT&gt;127){
        //(!!!!! 此处假定96(0X60)标识H264 并仅对H264进行处理 !!!!!)
        if(m_RTP_Header.PT != 96){
            return -2;
        }

        //提取H264 NAL头
        int nal_h_offset  = 12+m_RTP_Header.CC ;
        m_NAL_Header.F    =  RTP_PackegRawBuf[nal_h_offset] &gt;&gt;7;
        m_NAL_Header.NRI  = (RTP_PackegRawBuf[nal_h_offset] &amp;0x60)&gt;&gt;5;
        m_NAL_Header.Type =  RTP_PackegRawBuf[nal_h_offset] &amp;0x1f;

        //重要类型为 5,7,8,1? (25,27,28,65,67,68,21?...)
        m_NAL_Header.isMajor578 = 0 ;
        if(m_NAL_Header.Type==5 || m_NAL_Header.Type==7 ||
           m_NAL_Header.Type==8 || m_NAL_Header.Type==1 )
        {
            m_NAL_Header.isMajor578 = 1 ;
        }

        //此处仅处理多片FU-A(28)及单片的情况,其他情况直接返回
        if(m_NAL_Header.Type&gt;23 &amp;&amp; m_NAL_Header.Type!=28){
            return -2;
        }

        // 分片 FU-A
        if(m_NAL_Header.Type==28){
            m_NAL_Header.FUA_S    =  RTP_PackegRawBuf[nal_h_offset+1] &gt;&gt;7 ;
            m_NAL_Header.FUA_E    = (RTP_PackegRawBuf[nal_h_offset+1] &amp;0x40)&gt;&gt;6;
            m_NAL_Header.FUA_R    = 0 ;
            m_NAL_Header.FUA_Type =  RTP_PackegRawBuf[nal_h_offset+1] &amp;0x1f ;
            m_NAL_Header.size     = 2 ;
        }
        else{ //单片
            m_NAL_Header.FUA_S    = 0 ;
            m_NAL_Header.FUA_E    = 0 ;
            m_NAL_Header.FUA_R    = 0 ;
            m_NAL_Header.FUA_Type = 0 ;
            m_NAL_Header.size     = 1 ;
        }

        return 0;
    }

    //此函数未测试 - 2016年11月11日
    int CheckLostMajorPackeg(float *fLossRate)
    {
        bool isLost =0;

        static bool isFrame_loss[256] = {0} ;
        static unsigned char i = 0 ;
        static unsigned short seq_number_old = 0;

        //重要类型为 5,7,8 (25,27,28,65,67,68,...)
        bool isMajor = 0 ;
        unsigned char Type[2];
        Type[0] = m_NAL_Header.Type &amp;0x0f ;
        Type[1] = m_NAL_Header.FUA_Type &amp; 0x0f ;

        //判断是否有5 7 8
        for(int j=0;j&lt;2 &amp;&amp; isMajor==0;j++){
            switch(Type[j]){
                case 5:
                case 7:
                case 8: isMajor = 1 ; break;
                default: isMajor = 0 ;
            }
        }
        if(isMajor==0){
            //更新数据
            seq_number_old = m_RTP_Header.seq_number ;
            return 0;
        }

        //如果是重要帧
        //序列号应该递增
        isLost = 1 ;
        if(m_RTP_Header.seq_number-seq_number_old == 1){
            isLost = 0 ;
        }
        if(seq_number_old==0xffff &amp;&amp; m_RTP_Header.seq_number==0x0000){
            isLost = 0 ;
        }

        //计算丢包率
        float lossnum = 0.0 ;
        isFrame_loss[i++] = isLost ;
        for(int j=0;j&lt;256;j++){
            if(isFrame_loss[j])
                lossnum += 1.0 ;
        }
        *fLossRate = lossnum/256.0f ;

        //更新数据
        seq_number_old = m_RTP_Header.seq_number ;

        return (int)isLost;
    }

    int GetNALUnit_OneFrame(unsigned char *RTP_PackegRawBuf,int size)
    {
        int reValue = 0 ;

        float fLossRate =0.0;
        static int isLossPackeg = 0 ;

        //参数断定
        if(RTP_PackegRawBuf==NULL || size&lt;13){return -1;}

        GetHeader(RTP_PackegRawBuf,size);
        /*if(!isLossPackeg &amp;&amp; CheckLostMajorPackeg(&amp;fLossRate)){
            isLossPackeg = 1 ;
            printf("loss packeg: LossRate=%f ... \n",fLossRate);
        }

        //如果丢包，丢掉这一帧
        if(isLossPackeg){
            memset(H264_OneFrame, 0, H264_1f_size);
            H264_1f_size = 0 ;
            if(m_RTP_Header.M){ //如果帧结束，清零标记位
                isLossPackeg = 0 ;
            }
            return -1;
        }
        */
        //去壳、去头去尾
        unsigned char *playload = RTP_PackegRawBuf ;
        int playload_size = 0 ;
        int padding_size = 0 ;

        if(m_RTP_Header.P){  //尾部有多余数据
            padding_size = RTP_PackegRawBuf[size-1] ;
        }
        //数据大小及数据地址重新指向有效数据区域
        playload_size = size -(m_RTP_Header.size+m_NAL_Header.size) -padding_size +1;
        playload += m_RTP_Header.size + m_NAL_Header.size -1;

        //单片
        if(m_NAL_Header.size==1 &amp;&amp; !m_NAL_Header.isMajor578){
            playload -= 3 ;
            playload_size += 3 ;
            playload[0] =0x00; playload[1] =0x00; //写入头
            playload[2] =0x01;
        }
        else if(m_NAL_Header.size==1 &amp;&amp; m_NAL_Header.isMajor578){
            playload -= 4 ;
            playload_size += 4 ;
            playload[0] =0x00; playload[1] =0x00;
            playload[2] =0x00; playload[3] =0x01;
        }
        else if(m_NAL_Header.size==2){  //多片
            if(m_NAL_Header.FUA_S){     //分片开始
                playload -= 4 ;
                playload_size += 4 ;
                playload[4] = (playload[3]&amp;0xe0) + (playload[4]&amp;0x1f);//取FU indicator的前三位和FU Header的后五位为NAL类型。
                playload[0] =0x00; playload[1] =0x00; //写入头
                playload[2] =0x00; playload[3] =0x01;
            }
            else{
                playload += 1 ;         //除去 FU Header
                playload_size -= 1 ;
            }
        }
        //合并成一帧
        memcpy(H264_OneFrame+H264_1f_size, playload, playload_size);
        H264_1f_size += playload_size ;

        //帧结束标志
        if(m_RTP_Header.M){
            if(H264_1f_size&lt;pic_size3){ //size大小是否异常
                reValue = 1 ;
            }
            else{   //出错则清零
                memset(H264_OneFrame, 0, pic_size3);
                H264_1f_size = 0 ;
            }

            //以下仅用于文件测试
            //得到的视频文件可以用播放器打开
            //static int i=0;
            //printf("running %d... \n",i++);
/*          FILE *fp = fopen("test.264","ab+");
            int a = fwrite(H264_OneFrame,1,H264_1f_size,fp);
            if(a!=H264_1f_size){
                printf("write file test.264 ERROR ! \n");
            }
            fflush(fp);
            fclose(fp);
*/
            //memset(H264_OneFrame, 0, H264_1f_size);
            //H264_1f_size = 0 ;
            //以上仅用于测试

        }// end if(m_RTP_Header.M)

        return reValue ;
    }

};

// 2 class CH264_RTP_UNPACK_2 end
//////////////////////////////////////////////////////////////////////////////////////////  </code></pre>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li>
<li>17</li>
<li>18</li>
<li>19</li>
<li>20</li>
<li>21</li>
<li>22</li>
<li>23</li>
<li>24</li>
<li>25</li>
<li>26</li>
<li>27</li>
<li>28</li>
<li>29</li>
<li>30</li>
<li>31</li>
<li>32</li>
<li>33</li>
<li>34</li>
<li>35</li>
<li>36</li>
<li>37</li>
<li>38</li>
<li>39</li>
<li>40</li>
<li>41</li>
<li>42</li>
<li>43</li>
<li>44</li>
<li>45</li>
<li>46</li>
<li>47</li>
<li>48</li>
<li>49</li>
<li>50</li>
<li>51</li>
<li>52</li>
<li>53</li>
<li>54</li>
<li>55</li>
<li>56</li>
<li>57</li>
<li>58</li>
<li>59</li>
<li>60</li>
<li>61</li>
<li>62</li>
<li>63</li>
<li>64</li>
<li>65</li>
<li>66</li>
<li>67</li>
<li>68</li>
<li>69</li>
<li>70</li>
<li>71</li>
<li>72</li>
<li>73</li>
<li>74</li>
<li>75</li>
<li>76</li>
<li>77</li>
<li>78</li>
<li>79</li>
<li>80</li>
<li>81</li>
<li>82</li>
<li>83</li>
<li>84</li>
<li>85</li>
<li>86</li>
<li>87</li>
<li>88</li>
<li>89</li>
<li>90</li>
<li>91</li>
<li>92</li>
<li>93</li>
<li>94</li>
<li>95</li>
<li>96</li>
<li>97</li>
<li>98</li>
<li>99</li>
<li>100</li>
<li>101</li>
<li>102</li>
<li>103</li>
<li>104</li>
<li>105</li>
<li>106</li>
<li>107</li>
<li>108</li>
<li>109</li>
<li>110</li>
<li>111</li>
<li>112</li>
<li>113</li>
<li>114</li>
<li>115</li>
<li>116</li>
<li>117</li>
<li>118</li>
<li>119</li>
<li>120</li>
<li>121</li>
<li>122</li>
<li>123</li>
<li>124</li>
<li>125</li>
<li>126</li>
<li>127</li>
<li>128</li>
<li>129</li>
<li>130</li>
<li>131</li>
<li>132</li>
<li>133</li>
<li>134</li>
<li>135</li>
<li>136</li>
<li>137</li>
<li>138</li>
<li>139</li>
<li>140</li>
<li>141</li>
<li>142</li>
<li>143</li>
<li>144</li>
<li>145</li>
<li>146</li>
<li>147</li>
<li>148</li>
<li>149</li>
<li>150</li>
<li>151</li>
<li>152</li>
<li>153</li>
<li>154</li>
<li>155</li>
<li>156</li>
<li>157</li>
<li>158</li>
<li>159</li>
<li>160</li>
<li>161</li>
<li>162</li>
<li>163</li>
<li>164</li>
<li>165</li>
<li>166</li>
<li>167</li>
<li>168</li>
<li>169</li>
<li>170</li>
<li>171</li>
<li>172</li>
<li>173</li>
<li>174</li>
<li>175</li>
<li>176</li>
<li>177</li>
<li>178</li>
<li>179</li>
<li>180</li>
<li>181</li>
<li>182</li>
<li>183</li>
<li>184</li>
<li>185</li>
<li>186</li>
<li>187</li>
<li>188</li>
<li>189</li>
<li>190</li>
<li>191</li>
<li>192</li>
<li>193</li>
<li>194</li>
<li>195</li>
<li>196</li>
<li>197</li>
<li>198</li>
<li>199</li>
<li>200</li>
<li>201</li>
<li>202</li>
<li>203</li>
<li>204</li>
<li>205</li>
<li>206</li>
<li>207</li>
<li>208</li>
<li>209</li>
<li>210</li>
<li>211</li>
<li>212</li>
<li>213</li>
<li>214</li>
<li>215</li>
<li>216</li>
<li>217</li>
<li>218</li>
<li>219</li>
<li>220</li>
<li>221</li>
<li>222</li>
<li>223</li>
<li>224</li>
<li>225</li>
<li>226</li>
<li>227</li>
<li>228</li>
<li>229</li>
<li>230</li>
<li>231</li>
<li>232</li>
<li>233</li>
<li>234</li>
<li>235</li>
<li>236</li>
<li>237</li>
<li>238</li>
<li>239</li>
<li>240</li>
<li>241</li>
<li>242</li>
<li>243</li>
<li>244</li>
<li>245</li>
<li>246</li>
<li>247</li>
<li>248</li>
<li>249</li>
<li>250</li>
<li>251</li>
<li>252</li>
<li>253</li>
<li>254</li>
<li>255</li>
<li>256</li>
<li>257</li>
<li>258</li>
<li>259</li>
<li>260</li>
<li>261</li>
<li>262</li>
<li>263</li>
<li>264</li>
<li>265</li>
<li>266</li>
<li>267</li>
<li>268</li>
<li>269</li>
<li>270</li>
<li>271</li>
<li>272</li>
<li>273</li>
<li>274</li>
<li>275</li>
<li>276</li>
<li>277</li>
<li>278</li>
<li>279</li>
<li>280</li>
<li>281</li>
<li>282</li>
<li>283</li>
<li>284</li>
<li>285</li>
<li>286</li>
<li>287</li>
<li>288</li>
<li>289</li>
<li>290</li>
<li>291</li>
<li>292</li>
<li>293</li>
<li>294</li>
<li>295</li>
<li>296</li>
<li>297</li>
<li>298</li>
<li>299</li>
<li>300</li>
<li>301</li>
<li>302</li>
<li>303</li>
<li>304</li>
<li>305</li>
<li>306</li>
<li>307</li>
<li>308</li>
<li>309</li>
<li>310</li>
<li>311</li>
<li>312</li>
<li>313</li>
<li>314</li>
<li>315</li>
</ul>
<h2>FFMPEG解码实现</h2>
<pre><code>    终于到最后一步了。请编译ffmpeg与x264。网上虽然很多资料，但大多不行，要自己综合各方资料。请看上面的推荐链接。也许编译这一步会有点麻烦，耐心一点总可以解决。
</code></pre>
<h3>关于FFMPEG多线程问题：</h3>
<pre><code>    这里注意多线程问题，如果你用FFMPEG解多路视频的话，编译的时候请--enable-w32thread. 否则不好说，网上很多人都说多线程会出现问题，但也有人没有问题。而且就算你enable了多线程，里面有些函数也是不支持多线程的。比如说：
</code></pre>
<pre><code>/**
 ......
 * @warning This function is not thread safe!
 *
 * @note Always call this function before using decoding routines (such as
 .......
 */
int avcodec_open2(AVCodecContext *avctx, const AVCodec *codec, AVDictionary **options);</code></pre>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
</ul>
<h2>关于FFMPGE的例子：</h2>
<pre><code>    官方的资料里有PLAYER的例子，还有test文件夹下的decode例子。推荐一个文件api-h264-test.cpp，这个参考性很高。
    民间例子更多了，比如《最简单的基于FFmpeg的视频播放器 Simplest FFmpeg Player》雷霄骅。

    下面看一个由api-h264-test.cpp更装过来的函数。
</code></pre>
<pre><code>/*
    仅作测试
    功能：打开一个filepath文件并解码
*/
int C_FFMPEG_Decode::onlyforfun_and_test()
{
    AVFormatContext *pFormatCtx;
    int             i, videoindex;
    AVCodecContext  *pCodecCtx;
    AVCodec         *pCodec;

    char filepath[]="test.264";
    //char filepath[]="rtsp://192.168.70.231/majorvideo_and_audio";
    //char filepath[]="rtsp://192.168.70.179/majorvideo_and_audio";

    av_register_all();
    //avformat_network_init();
    pFormatCtx = avformat_alloc_context();

    if(avformat_open_input(&amp;pFormatCtx,filepath,NULL,NULL)!=0){
        printf("Couldn't open input stream.（无法打开输入流）\n");
        return -1;
    }
    if(avformat_find_stream_info(pFormatCtx,NULL)&lt;0){
        printf("Couldn't find stream information.（无法获取流信息）\n");
        return -1;
    }
    videoindex=-1;
    for(i=0; i&lt;pFormatCtx-&gt;nb_streams; i++)
        if(pFormatCtx-&gt;streams[i]-&gt;codec-&gt;codec_type==AVMEDIA_TYPE_VIDEO){
            videoindex=i;
            break;
        }
    if(videoindex==-1){
        printf("Didn't find a video stream.（没有找到视频流）\n");
        return -1;
    }
    pCodecCtx=pFormatCtx-&gt;streams[videoindex]-&gt;codec;
    pCodec=avcodec_find_decoder(pCodecCtx-&gt;codec_id);
    if(pCodec==NULL)
    {
        printf("Codec not found.（没有找到解码器）\n");
        return -1;
    }
    if(avcodec_open2(pCodecCtx, pCodec,NULL)&lt;0)
    {
        printf("Could not open codec.（无法打开解码器）\n");
        return -1;
    }

    //初始化参数，下面的参数应该由具体的业务决定
    //pCodec    = avcodec_find_decoder(CODEC_ID_H264);
    //pCodecCtx = avcodec_alloc_context3(pCodec);
    //avcodec_open2(pCodecCtx, pCodec, NULL);

    pCodecCtx-&gt;time_base.num    = 1         ;
    pCodecCtx-&gt;frame_number     = 1         ; //每包一个视频帧
    pCodecCtx-&gt;codec_type       = AVMEDIA_TYPE_VIDEO;
    pCodecCtx-&gt;bit_rate         = 0         ;
    pCodecCtx-&gt;time_base.den    = 25        ; //帧率
    pCodecCtx-&gt;width            = 384       ; //视频宽
    pCodecCtx-&gt;height           = 288       ; //视频高  

    AVFrame *pFrame,*pFrameYUV;
    pFrame=av_frame_alloc();
    pFrameYUV=av_frame_alloc();
    uint8_t *out_buffer=(uint8_t *)av_malloc(avpicture_get_size(AV_PIX_FMT_YUV444P, pCodecCtx-&gt;width, pCodecCtx-&gt;height));
    avpicture_fill((AVPicture *)pFrameYUV, out_buffer, AV_PIX_FMT_YUV444P, pCodecCtx-&gt;width, pCodecCtx-&gt;height);

    int ret, got_picture;

    AVPacket *packet=(AVPacket *)av_malloc(sizeof(AVPacket));
    //输出一下信息-----------------------------
    printf("File Information（文件信息）---------------------\n");
    av_dump_format(pFormatCtx,0,filepath,0);
    printf("-------------------------------------------------\n");

    struct SwsContext *img_convert_ctx;
    img_convert_ctx = sws_getContext(pCodecCtx-&gt;width, pCodecCtx-&gt;height, pCodecCtx-&gt;pix_fmt, pCodecCtx-&gt;width, pCodecCtx-&gt;height, AV_PIX_FMT_YUV444P, SWS_BICUBIC, NULL, NULL, NULL);
    //--------------

    //Event Loop
    for (;;) {
        //Wait
        if(1){
            //------------------------------
            Sleep(40);
            if(av_read_frame(pFormatCtx, packet)&gt;=0){
                if(packet-&gt;stream_index==videoindex){
                    ret = avcodec_decode_video2(pCodecCtx, pFrame, &amp;got_picture, packet);
                    if(ret &lt; 0){
                        printf("Decode Error.（解码错误）\n");
                        return -1;
                    }
                    if(got_picture){
                        sws_scale(img_convert_ctx, (const uint8_t* const*)pFrame-&gt;data, pFrame-&gt;linesize, 0, pCodecCtx-&gt;height, pFrameYUV-&gt;data, pFrameYUV-&gt;linesize);

                        /////
                        int rows = pCodecCtx-&gt;height ;
                        int cols = pCodecCtx-&gt;width ;
                        if(rows &amp;&amp; cols){

                            /* 请加入opencv
/*                          Mat imgBGR = Mat(rows,cols,CV_8UC3);
                            Mat img[3];
                            img[0] = Mat(rows,cols,CV_8UC1);
                            img[1] = Mat(rows,cols,CV_8UC1);
                            img[2] = Mat(rows,cols,CV_8UC1);

                            int size = rows*cols;
                            memcpy(img[0].data, pFrameYUV-&gt;data[0], size);
                            memcpy(img[1].data, pFrameYUV-&gt;data[1], size);
                            memcpy(img[2].data, pFrameYUV-&gt;data[2], size);

                            merge(img,3,imgBGR);

                            cvtColor(imgBGR,imgBGR,CV_YUV2BGR);
                            imshow("opencv",imgBGR);
                            waitKey(1);
*/                      }
                        ///////

                    }
                }
                av_free_packet(packet);
            }else{
                //Exit Thread
                break;
            }
        }

    }

    sws_freeContext(img_convert_ctx);

    //--------------
    av_free(out_buffer);
    av_free(pFrameYUV);
    avcodec_close(pCodecCtx);
    avformat_close_input(&amp;pFormatCtx);

    return 0;
}</code></pre>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li>
<li>17</li>
<li>18</li>
<li>19</li>
<li>20</li>
<li>21</li>
<li>22</li>
<li>23</li>
<li>24</li>
<li>25</li>
<li>26</li>
<li>27</li>
<li>28</li>
<li>29</li>
<li>30</li>
<li>31</li>
<li>32</li>
<li>33</li>
<li>34</li>
<li>35</li>
<li>36</li>
<li>37</li>
<li>38</li>
<li>39</li>
<li>40</li>
<li>41</li>
<li>42</li>
<li>43</li>
<li>44</li>
<li>45</li>
<li>46</li>
<li>47</li>
<li>48</li>
<li>49</li>
<li>50</li>
<li>51</li>
<li>52</li>
<li>53</li>
<li>54</li>
<li>55</li>
<li>56</li>
<li>57</li>
<li>58</li>
<li>59</li>
<li>60</li>
<li>61</li>
<li>62</li>
<li>63</li>
<li>64</li>
<li>65</li>
<li>66</li>
<li>67</li>
<li>68</li>
<li>69</li>
<li>70</li>
<li>71</li>
<li>72</li>
<li>73</li>
<li>74</li>
<li>75</li>
<li>76</li>
<li>77</li>
<li>78</li>
<li>79</li>
<li>80</li>
<li>81</li>
<li>82</li>
<li>83</li>
<li>84</li>
<li>85</li>
<li>86</li>
<li>87</li>
<li>88</li>
<li>89</li>
<li>90</li>
<li>91</li>
<li>92</li>
<li>93</li>
<li>94</li>
<li>95</li>
<li>96</li>
<li>97</li>
<li>98</li>
<li>99</li>
<li>100</li>
<li>101</li>
<li>102</li>
<li>103</li>
<li>104</li>
<li>105</li>
<li>106</li>
<li>107</li>
<li>108</li>
<li>109</li>
<li>110</li>
<li>111</li>
<li>112</li>
<li>113</li>
<li>114</li>
<li>115</li>
<li>116</li>
<li>117</li>
<li>118</li>
<li>119</li>
<li>120</li>
<li>121</li>
<li>122</li>
<li>123</li>
<li>124</li>
<li>125</li>
<li>126</li>
<li>127</li>
<li>128</li>
<li>129</li>
<li>130</li>
<li>131</li>
<li>132</li>
<li>133</li>
<li>134</li>
<li>135</li>
<li>136</li>
<li>137</li>
<li>138</li>
<li>139</li>
<li>140</li>
<li>141</li>
<li>142</li>
<li>143</li>
<li>144</li>
<li>145</li>
<li>146</li>
<li>147</li>
<li>148</li>
<li>149</li>
<li>150</li>
</ul>
<pre><code>    这里需要注意的是，视频的宽、高、帧率、输入格式、输出格式等。
    细心者可以看到，这里可以直接打开URL。是的，但是不能打开所有URL。如果自己实现RTSP协议，则可以打开足够多类型的URL。
    如果是打开URL，那接收buffer要足够大，不然会花屏、卡、跳帧等。
</code></pre>
<p>如果自己实现RTSP/RTP，那么就要自己填充AVPacket了(AVPacket是FFMPEG中一个为数不多的重要结构体！)。参考代码如下：</p>
<pre><code>//申请输入码流包空间
    //packet = (AVPacket *)av_malloc(sizeof(AVPacket));
    packet = av_packet_alloc();
    av_init_packet(packet);
    packet-&gt;data = (uint8_t *)av_malloc(width*height*3+64); //编码包数据空间(不可能比原图更大了)
    memset(packet-&gt;data, 0, width*height*3+64);             //加64是因为有些CPU是每次读32/64位
    packet-&gt;size = 0 ;  //未有数据设为0
.....
packet-&gt;size = nal_size ;
memcpy(packet-&gt;data, packet-&gt;size,nal_data);
......
avcodec_decode_video2(...)
.....
memset(packet-&gt;data, 0, width*height*3+64);
packet-&gt;size = 0 ;
......</code></pre>
<ul>
<li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li>
<li>13</li>
<li>14</li>
<li>15</li>
<li>16</li>
</ul>
<p>看看总体效果图 <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjExMTExNzAyMTI4MDc=.jpg"> <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjExMTExNzAyMzY2ODI=.jpg"></p>
<p>一直从网上索取资料，今天终于抽出时间写一篇原创了 <br />感谢以上提到的链接的作者 <br />2016年11月11日 广州 <br />Newyan</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 10:44:18</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/http/" title="http">http</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>ONVIF、RTSP/RTP、FFMPEG的开发实录的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5NLRAz.html" rel="bookmark">FFMPEG SDK 开发介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				FFMPEG SDK 开发介绍 1.简介:     ffmpeg是一套可以用来记录.转换数字音频.视频,并能将其转化为流的开源计算机程序. 使用ffmpeg能够完成如下功能:parse,demux,decode,filter(preprocessing),encode,mux,stream和player等. 2.下载和编译:     下载地址:  http://ffmpeg.org/download.html     编译:        1)windows平台static library/sh			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgRRy8b.html" rel="bookmark">【FFMpeg视频开发与应用基础】一、使用FFmpeg命令行工具和批处理脚本进行简单的音视频文件编辑</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;FFMpeg视频开发与应用基础--使用FFMpeg工具与SDK&gt;视频教程已经在&quot;CSDN学院&quot;上线,视频中包含了从0开始逐行代码实现FFMpeg视频开发的过程,欢迎观看!链接地址:FFMpeg视频开发与应用基础--使用FFMpeg工具与SDK 工程代码地址:FFmpeg_Tutorial 1.基本介绍 对于每一个从事音视频技术开发的工程师,想必没有一个人对FFmpeg这个名称感到陌生.FFmpeg是一套非常知名的音视频处理的开源工具,它包含了开发完成的工具软件.封装好的函			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOJK6mp.html" rel="bookmark">【FFMpeg视频开发与应用基础】二、调用FFmpeg SDK对YUV视频序列进行编码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;FFMpeg视频开发与应用基础--使用FFMpeg工具与SDK&gt;视频教程已经在&quot;CSDN学院&quot;上线,视频中包含了从0开始逐行代码实现FFMpeg视频开发的过程,欢迎观看!链接地址:FFMpeg视频开发与应用基础--使用FFMpeg工具与SDK 工程代码地址:FFmpeg_Tutorial 视频由像素格式编码为码流格式是FFMpeg的一项基本功能.通常,视频编码器的输入视频通常为原始的图像像素值,输出格式为符合某种格式规定的二进制码流. 1.FFMpeg进行视频编码所需要的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3J9wJz.html" rel="bookmark">【FFMpeg视频开发与应用基础】三、调用FFmpeg SDK对H&period;264格式的视频压缩码流进行解码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;FFMpeg视频开发与应用基础--使用FFMpeg工具与SDK&gt;视频教程已经在&quot;CSDN学院&quot;上线,视频中包含了从0开始逐行代码实现FFMpeg视频开发的过程,欢迎观看!链接地址:FFMpeg视频开发与应用基础--使用FFMpeg工具与SDK 工程代码地址:FFmpeg_Tutorial 经过了上篇调用FFMpeg SDK对视频进行编码的过程之后,我们可以比较容易地理解本篇的内容,即上一篇的逆过程--将H.264格式的裸码流解码为像素格式的图像信息. 1.FFMpeg视频			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8Y0qNz.html" rel="bookmark">【FFMpeg视频开发与应用基础】八、 调用FFMpeg SDK实现视频缩放</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;FFMpeg视频开发与应用基础--使用FFMpeg工具与SDK&gt;视频教程已经在&quot;CSDN学院&quot;上线,视频中包含了从0开始逐行代码实现FFMpeg视频开发的过程,欢迎观看!链接地址:FFMpeg视频开发与应用基础--使用FFMpeg工具与SDK Github工程代码地址:FFmpeg_Tutorial 视频缩放是视频开发中一项最基本的功能.通过对视频的像素数据进行采样或插值,可以将低分辨率的视频转换到更高的分辨率,或者将高分辨率的视频转换为更低的分辨率.通过FFMpeg提供			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pX0X8vp.html" rel="bookmark">【FFMpeg视频开发与应用基础】五、调用FFMpeg SDK封装音频和视频为视频文件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;FFMpeg视频开发与应用基础--使用FFMpeg工具与SDK&gt;视频教程已经在&quot;CSDN学院&quot;上线,视频中包含了从0开始逐行代码实现FFMpeg视频开发的过程,欢迎观看!链接地址:FFMpeg视频开发与应用基础--使用FFMpeg工具与SDK 工程代码地址:FFmpeg_Tutorial 音频和视频的封装过程为解封装的逆过程,即将独立的音频数据和视频数据按照容器文件所规定的格式封装为一个完整的视频文件的过程.对于大多数消费者来说,视频封装的容器是大家最为熟悉的,因为它直接			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlL6BnM.html" rel="bookmark">【FFMpeg视频开发与应用基础】六、调用FFMpeg SDK实现视频文件的转封装</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;FFMpeg视频开发与应用基础--使用FFMpeg工具与SDK&gt;视频教程已经在&quot;CSDN学院&quot;上线,视频中包含了从0开始逐行代码实现FFMpeg视频开发的过程,欢迎观看!链接地址:FFMpeg视频开发与应用基础--使用FFMpeg工具与SDK 工程代码地址:FFmpeg_Tutorial 有时候我们可能会面对这样的一种需求,即我们不需要对视频内的音频或视频信号进行什么实际的操作,只是希望能把文件的封装格式进行转换,例如从avi转换为mp4格式或者flv格式等.实际上,转封			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWdQOmp.html" rel="bookmark">【FFMpeg视频开发与应用基础】七、 调用FFMpeg SDK实现视频水印</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;FFMpeg视频开发与应用基础--使用FFMpeg工具与SDK&gt;视频教程已经在&quot;CSDN学院&quot;上线,视频中包含了从0开始逐行代码实现FFMpeg视频开发的过程,欢迎观看!链接地址:FFMpeg视频开发与应用基础--使用FFMpeg工具与SDK Github工程代码地址:FFmpeg_Tutorial 视频的水印通常指附加在原始视频上的可见或者不可见的,与原始视频无直接关联的标识.通常在有线电视画面上电视台的台标以及视频网站上的logo就是典型的视频水印的应用场景.通常实现			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPWR3qM.html" rel="bookmark">RTSP - RTP over TCP</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Normally, RTSP provide streaming over UDP. By nature, UDP is a better choice as it provides robust streaming capability for media. However, it is unlikely to use UDP for streaming over the Internet. 通常来说,RTSP提供UDP方式发送RTP流.当然,发送流媒体时,UDP往往是更好的选择.但是,在互联			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPB9Zb.html" rel="bookmark" class="title">网站开发人员应该知道的61件事</a>
					<div>
						有人在Stack Overflow上发问,动手开发网站之前,需要知道哪些事情? 不出意料地,他得到了一大堆回答. 通常情况下,你需要把所有人的发言从头到尾读一遍.但是,Stack Overflow有一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAvwep.html" rel="bookmark" class="title">新闻更新系统&lpar;3&rpar;</a>
					<div>
						制作更新文件      作者:米仙圣人       更新文件是新闻维护者在本地写的一个程序,你可以采用多种工具来写,在这里作者是采用Delphi写的一个程序.在这里就不多做阐述.    更新文件的特点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjNQ0b.html" rel="bookmark" class="title">flash和asp分页的一点心得</a>
					<div>
						分页|心得 看了这个的一些帖子,学到了很多东西,现在和大家一起分享 flash现在只是一个显示的功能,过程中看了一些别人的东西,觉得分页似乎有很简单的实现方式.基本上都是用xml传送的.显示用 lis ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEe2ob.html" rel="bookmark" class="title">在JSP的页面上可以通过&amp;amp&semi;&num;106avascript来截获键盘的按键事件</a>
					<div>
						js|页面 页面中的键盘控制 Capturing Keystrokes 相应敲击键是电脑和人的基本相互作用.你可以控制任何一个键的按下和松开.首先我们先要知道如何启动一个所谓的事件 (event).  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrOAxp.html" rel="bookmark" class="title">OLE DB提供者</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2y4Xvz.html" rel="bookmark" class="title">教你学会怎样升级到SQL Anywhere 10（9）</a>
					<div>
						升级MobiLink服务器 在使用MobiLink服务器版本10之前,请仔细检查行为变更是否会影响应用. MobiLink服务器版本10仅支持版本8和9的SQL Anywhere和UltraLite客 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBdPyb.html" rel="bookmark" class="title">如何设置Word 2013文档的页码格式</a>
					<div>
						通过设置Word2013文档页码格式,用户可以选择多种类型的页码数字样式,从而使插入的页码更美观.更实用.并且页码格式还包括&quot;起始页码&quot;选项,该功能在多节Word文档中尤其实用.在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLoLRb.html" rel="bookmark" class="title">LINQ体验&lpar;13&rpar;&mdash;&mdash;LINQ to SQL语句之运算符转换和ADO&period;NET与LINQ to SQL</a>
					<div>
						运算符转换1.AsEnumerable:将类型转换为泛型 IEnumerable 使用 AsEnumerable&lt;TSource&gt; 可返回类型化为泛型 IEnumerable 的参数.在  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNVaDb.html" rel="bookmark" class="title">WPS表格 期末考试 提高教师效率手册</a>
					<div>
						辛勤的老师们又迎来了每学期一次的期末考试:考生的排座,考场桌签的制作,学生成绩的统计分析,学生成绩单的制作......怎么才能提高这些工作的效率呢?以下是教程区里各位大虾编写的效率教程,希望能助老师们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6A5Vz.html" rel="bookmark" class="title">excel2013数据透视表如何制作</a>
					<div>
						  excel透视表制作步骤如下: 1.用Excel2013打开一篇工作表,切换到&quot;插入&quot;选项卡,单击&quot;表格&quot;组中的&quot;推荐的数据透视表&quot;按钮 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Aa8Ap.html" rel="bookmark" class="title">如何在局域网中抢网速</a>
					<div>
						方法一.首先自己要对路由器的设置比较熟悉,先查看自己的本地连接和adsl连接的属性,然后找到自己设置ip和dns地址,不要设置默认的自动获取地址,要自己设置ip地址和dns地址,dns地址最好是本地服 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGoZap.html" rel="bookmark" class="title">如何将成批文件一次生成？</a>
					<div>
						  如果你要用一个模版文件快速生成以全公司数百人的名字命名的个性化文件,如何才能办到?下面小编来告诉你如何将成批文件一次生成,一次生成数百文件怎么做? 为了快速完成一项工作,公司开展全员合作,需要每位 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3N1BM.html" rel="bookmark" class="title">福利来了！！！ - PostgreSQL9&period;5架构图及外存图</a>
					<div>
						放出两张PostgreSQL 9.5的架构图及外存图,希望能够帮到正在PG路上奔波的朋友们-					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NqOyM.html" rel="bookmark" class="title">盛大麦库推出PC桌面客户端</a>
					<div>
						麦库是盛大于去年8月份推出了一个免费.永久在线,安全的个人在线http://www.aliyun.com/zixun/aggregation/12530.html&quot;&gt;知识管理平台.您可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NyKLM.html" rel="bookmark" class="title">ultraiso 9&period;6 注册码</a>
					<div>
						多国语言版注册码: 用户名:Steve Olson 注册码:2BEC-ED28-82BB-95D7 简体中文版注册码: 用户名:maozhuxi 注册码:7C81-1689-4046-626F					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYja8Vp.html" rel="bookmark" class="title">ios-iPhone中如何添加paypal sdk</a>
					<div>
						问题描述 iPhone中如何添加paypal sdk 开发的应用需要用到paypal sdk,我添加了所有提到的框架,但是还是报错: Undefined symbols for architectur ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrZjrM.html" rel="bookmark" class="title">关于jvm基本数据类型以及引用类型内存存储问题</a>
					<div>
						问题描述 关于jvm基本数据类型以及引用类型内存存储问题 1,所有的基本数据类型和引用类型都存放在栈中吗?不需要考虑是在哪个位置定义的 吗(方法内还是作为成员变量定义) 2,方法内的final修饰的常 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamWEJb.html" rel="bookmark" class="title">ios-高手求助：传递NSError到方法中</a>
					<div>
						问题描述 高手求助:传递NSError到方法中 有一个方法,参数: (void(^)(NSError*))errorCall; 需要传递errorCall值: -(void)message{ exam ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVN5mlz.html" rel="bookmark" class="title">快速排序的非递归实现 -- 人人网2014笔试题目</a>
					<div>
						快速排序是各大公司笔试面试中出现频率最高的几个之一,因为它在实际应用中经常用到! 在看快速排序的的非递归之前我们先看看几种经典的快速排序的递归的实现. /* *BLOG:http://blog.csd ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKR2ab.html" rel="bookmark" class="title">方法-怎样能将网站所有的中文都转化成俄文？</a>
					<div>
						问题描述 怎样能将网站所有的中文都转化成俄文? 有没有一种方法能将制作好的网站上所有的中文都转化成各种国家的语言? 解决方案 怎么可能--不同语种语法不同,翻译出来的语句都不一样的(中文的简繁体可以直 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94NOKb.html" rel="bookmark" class="title">搜索正在进入&OpenCurlyDoubleQuote;灵动&rdquo;时代智能交互未来</a>
					<div>
						前天,&lt;星际穿越&gt;在上海试片,该片和&lt;三体&gt;的相似度让部分观众开玩笑称:&quot;诺兰在拍摄&lt;星际穿越&gt;时是不是已经提前看了&lt;三体&gt;.&quot;不少 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQB9a8M.html" rel="bookmark" class="title">javascript做计算器-用javascript做一个计算器怎样才能让数字按键上的数字显示在上面的文本框中</a>
					<div>
						问题描述 用javascript做一个计算器怎样才能让数字按键上的数字显示在上面的文本框中 用javascript做一个计算器怎样才能让数字按键上的数字显示在上面的文本框中 解决方案 参考这个完整的例 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rnJjp.html" rel="bookmark" class="title">sql-Sqlserver 2005创建登录名失败？？急~~~</a>
					<div>
						问题描述 Sqlserver 2005创建登录名失败??急~~~ 我电脑里安装的是sqlserver2005 我想创建一个使用sql验证的用户名,但是怎么都不成功, 总是显示说什么权限不够~~ 下面是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE4P8Jz.html" rel="bookmark" class="title">HTML Agility Pack 搭配 ScrapySharp，彻底解除Html解析的痛苦</a>
					<div>
						自从 Web 应用程序自 1993 年 W3C 设立以来就开始发展,而且 HTML 也历经了数个版本的演化(1.0 – 2.0 – 3.0 – 3.2 – 4.0 – 4.01),现在也已经成为Web ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RoEnz.html" rel="bookmark" class="title">互联网身份&OpenCurlyDoubleQuote;悖论&rdquo;到底是怎么回事？</a>
					<div>
						如同腾讯.百度.新浪等国内科技公司已经经过的重重考验一样,有望成为有史以来最大规模IPO的阿里巴巴,正在遭受资本市场上的诸多审视. 近日,有媒体曝出消息称,阿里巴巴近期与中国兵器工业集团签订了协议,合 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jkORp.html" rel="bookmark" class="title">传受到丈夫连累酒井法子遭黑帮&OpenCurlyDoubleQuote;江湖追杀令&rdquo;</a>
					<div>
						据香港媒体报道,酒井法子的老公高相佑一日前保释外出,有传日本黑帮立刻发出&quot;江湖追杀令&quot;,禁止他供出重要内幕,并连累酒井法子被追杀!而日本警方表示将严查毒品源头,与酒井夫妇同是冲浪爱 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1ANWb.html" rel="bookmark" class="title">如何捕获 Linux 图形化登录界面的截图</a>
					<div>
						在上一篇博客「重返 Linux 世界」中,我说 Linux Mint 17.2 的登录界面比之前的要好看不少.作为佐证,我贴了一张 Linux Mint 登录界面的截图. 在日常使用中,我们的截图操作 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZm75Op.html" rel="bookmark" class="title">flag-启动第三方应用时，设置FLAG&lowbar;ACTIVITY&lowbar;REORDER&lowbar;TO&lowbar;FRONT无效</a>
					<div>
						问题描述 启动第三方应用时,设置FLAG_ACTIVITY_REORDER_TO_FRONT无效 1.A.B.C3个项目,A.B为C的library,A.B平级. 2.A可以跳转到B,B可以跳转到A. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK01oZM.html" rel="bookmark" class="title">初始化任务Bootstrapper</a>
					<div>
						每个应用程序都需要在启动的时候做些初始化任务,在退出的时候做些清理工作,这类任务被归为Bootstrapper,在codeplex上的开源项目,详见 http://bootstrapper.codep ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlAP6Vp.html" rel="bookmark" class="title">首款APP社交手机壳 &OpenCurlyDoubleQuote;云壳&rdquo;预定量超3万</a>
					<div>
						这款拥有电子名片功能的手机壳从一诞生,就在众多手机壳品牌中http://www.aliyun.com/zixun/aggregation/7814.html&quot;&gt;脱颖而出,Name.im ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.049 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
